%{
static int CheckDriverExtension(struct connection *connection,SQLUINTEGER mask) {
	SQLRETURN ret;
	SQLUINTEGER extensions;

	ret = SQLGetInfo(connection->dbc,SQL_GETDATA_EXTENSIONS,
			 (SQLPOINTER)&extensions,0,NULL);
	if (!SQL_SUCCEEDED(ret)) return FALSE;
	if ((extensions & mask) != 0) return TRUE;
	else return FALSE;
}
%}
struct connection {
};

#if SWIGVERSIONMINOR == 1 && SWIGVERSIONMAJOR == 1
%addmethods
#else
%extend
#endif
	connection {
	~connection() {
		SQLDisconnect(self->dbc);
		SQLFreeHandle(SQL_HANDLE_DBC,self->dbc);
		Tcl_Free((char *)self);
	}
	/* SQLGetInfo() and SQLGetConnectAttr() calls */
	Tcl_Result cget(Tcl_Interp *interp,const char *what) {
		SQLRETURN ret;
		SQLCHAR tempstring[256];
		SQLUSMALLINT tempsmallint;
		SQLUINTEGER  tempint;
		/* First, SQLGetInfo() ... */
		if (strncasecmp(what,"-accessible_tables",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_ACCESSIBLE_TABLES,
				   (SQLPOINTER)tempstring,
                                   sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -accessible_tables",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			if (strcasecmp(tempstring,"Y") == 0)
				Tcl_SetObjResult(interp,Tcl_NewBooleanObj(1));
			else	Tcl_SetObjResult(interp,Tcl_NewBooleanObj(0));
			return TCL_OK;
		} else if (strncasecmp(what,"-accessible_procedures",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_ACCESSIBLE_PROCEDURES,
				   (SQLPOINTER)tempstring,
                                   sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -accessible_procedures",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			if (strcasecmp(tempstring,"Y") == 0)
				Tcl_SetObjResult(interp,Tcl_NewBooleanObj(1));
			else	Tcl_SetObjResult(interp,Tcl_NewBooleanObj(0));
			return TCL_OK;
		} else if (strncasecmp(what,"-active_environments",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_ACTIVE_ENVIRONMENTS,
				   (SQLPOINTER)&tempsmallint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -active_environments",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewIntObj(tempsmallint));
			return TCL_OK;
		} else if (strncasecmp(what,"-aggregate_functions",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_AGGREGATE_FUNCTIONS,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -aggregate_functions",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_AF_ALL) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("all",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_AF_AVG) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("ave",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_AF_COUNT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("count",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_AF_DISTINCT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("distinct",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_AF_MAX) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("max",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_AF_MIN) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("min",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_AF_SUM) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sum",-1)) == TCL_ERROR) return TCL_ERROR;
			}
 			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-alter_domain",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_ALTER_DOMAIN,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -alter_domain",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_AD_ADD_DOMAIN_CONSTRAINT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("add_domain_constraint",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_AD_ADD_DOMAIN_DEFAULT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("add_domain_default",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_AD_CONSTRAINT_NAME_DEFINITION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("constraint_name_definition",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_AD_DROP_DOMAIN_CONSTRAINT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("drop_domain_constraint",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_AD_DROP_DOMAIN_DEFAULT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("drop_domain_default",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_AD_ADD_CONSTRAINT_DEFERRABLE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("add_constraint_deferrable",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_AD_ADD_CONSTRAINT_NON_DEFERRABLE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("add_constraint_non_deferrable",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_AD_ADD_CONSTRAINT_INITIALLY_DEFERRED) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("add_constraint_initially_deferred",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_AD_ADD_CONSTRAINT_INITIALLY_IMMEDIATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("add_constraint_initially_immediate",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-alter_table",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_ALTER_TABLE,
 				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -alter_table",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_AT_ADD_COLUMN_COLLATION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("add_column_collation",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_AT_ADD_COLUMN_DEFAULT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("add_column_default",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_AT_ADD_COLUMN_SINGLE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("add_column_single",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_AT_ADD_CONSTRAINT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("add_constraint",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_AT_ADD_TABLE_CONSTRAINT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("add_table_constraint",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_AT_CONSTRAINT_NAME_DEFINITION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("constraint_name_definition",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_AT_DROP_COLUMN_CASCADE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("drop_column_cascade",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_AT_DROP_COLUMN_DEFAULT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("drop_column_default",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_AT_DROP_COLUMN_RESTRICT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("drop_column_restrict",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_AT_DROP_TABLE_CONSTRAINT_CASCADE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("drop_table_constraint_cascade",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_AT_DROP_TABLE_CONSTRAINT_RESTRICT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("drop_table_constraint_restrict",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_AT_SET_COLUMN_DEFAULT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("set_column_default",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_AT_CONSTRAINT_INITIALLY_DEFERRED) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("constraint_initially_deferred",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_AT_CONSTRAINT_INITIALLY_IMMEDIATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("constraint_initially_immediate",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_AT_CONSTRAINT_DEFERRABLE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("constraint_deferrable",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_AT_CONSTRAINT_NON_DEFERRABLE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("constraint_non_deferrable",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-async_mode",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_ASYNC_MODE,
 				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -async_mode",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
 			switch (tempint) {
 			   case SQL_AM_CONNECTION:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("connection",-1));
				return TCL_OK;
 			   case SQL_AM_STATEMENT:
 				Tcl_SetObjResult(interp,Tcl_NewStringObj("statement",-1));
				return TCL_OK;
			   case SQL_AM_NONE:
 				Tcl_SetObjResult(interp,Tcl_NewStringObj("none",-1));
				return TCL_OK;
			   default:
			   	Tcl_SetObjResult(interp,Tcl_NewStringObj("unknown result",-1));
			   	return TCL_ERROR;
			}
		} else if (strncasecmp(what,"-batch_row_count",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_BATCH_ROW_COUNT,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -batch_row_count",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_BRC_ROLLED_UP) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("rolled_up",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_BRC_PROCEDURES) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("procedures",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_BRC_EXPLICIT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("explicit",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-batch_support",strlen(what)) == 0) {
		   	ret = SQLGetInfo(self->dbc,SQL_BATCH_SUPPORT,
		   		   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -batch_support",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_BS_SELECT_EXPLICIT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("select_explicit",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_BS_ROW_COUNT_EXPLICIT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("row_count_explicit",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_BS_SELECT_PROC) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("select_proc",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_BS_ROW_COUNT_PROC) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("row_count_proc",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-bookmark_persistence",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_BOOKMARK_PERSISTENCE,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -bookmark_persistence",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_BP_CLOSE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("close",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_BP_DELETE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("delete",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_BP_DROP) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("drop",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_BP_TRANSACTION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("transaction",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_BP_UPDATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("update",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_BP_OTHER_HSTMT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("other_hstmt",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-catalog_location",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_CATALOG_LOCATION,
				   (SQLPOINTER)&tempsmallint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -catalog_location",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			switch  (tempsmallint) {
			    case SQL_CL_START:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("start",-1));
				return TCL_OK;
			    case SQL_CL_END:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("end",-1));
				return TCL_OK;
			    case 0:
			    	Tcl_SetObjResult(interp,Tcl_NewStringObj("catalogs are not supported",-1));
			    	return TCL_OK;
			    default:
			    	Tcl_SetObjResult(interp,Tcl_NewStringObj("unknown result",-1));
			   	return TCL_ERROR;
			}
		} else if (strncasecmp(what,"-catalog_name",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_CATALOG_NAME,
				   (SQLPOINTER)tempstring,sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -catalog_name",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			if (strcasecmp(tempstring,"Y") == 0)
				Tcl_SetObjResult(interp,Tcl_NewBooleanObj(1));
			else	Tcl_SetObjResult(interp,Tcl_NewBooleanObj(0));
			return TCL_OK;
		} else if (strncasecmp(what,"-catalog_name_separator",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_CATALOG_NAME_SEPARATOR,
				   (SQLPOINTER)tempstring,sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -catalog_name_separator",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewStringObj(tempstring,-1));
			return TCL_OK;
		} else if (strncasecmp(what,"-catalog_term",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_CATALOG_TERM,
				   (SQLPOINTER)tempstring,sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -catalog_term",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewStringObj(tempstring,-1));
			return TCL_OK;
		} else if (strncasecmp(what,"-catalog_usage",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_CATALOG_USAGE,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -catalog_usage",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_CU_DML_STATEMENTS) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("dml_statements",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CU_PROCEDURE_INVOCATION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("procedure_invocation",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CU_TABLE_DEFINITION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("table_definition",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CU_INDEX_DEFINITION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("index_definition",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CU_PRIVILEGE_DEFINITION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("privilege_definition",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-collation_seq",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_COLLATION_SEQ,
				   (SQLPOINTER)tempstring,sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -collation_seq",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewStringObj(tempstring,-1));
			return TCL_OK;
		} else if (strncasecmp(what,"-column_alias",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_COLUMN_ALIAS,
				   (SQLPOINTER)tempstring,sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -column_alias",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			if (strcasecmp(tempstring,"Y") == 0)
				Tcl_SetObjResult(interp,Tcl_NewBooleanObj(1));
			else	Tcl_SetObjResult(interp,Tcl_NewBooleanObj(0));
			return TCL_OK;
		} else if (strncasecmp(what,"-concat_null_behavior",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_CONCAT_NULL_BEHAVIOR,
				   (SQLPOINTER)&tempsmallint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -concat_null_behavior",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			switch (tempsmallint) {
			   case SQL_CB_NULL:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("null",-1));
				return TCL_OK;
			   case SQL_CB_NON_NULL:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("non_null",-1));
				return TCL_OK;
			   default:
			   	Tcl_SetObjResult(interp,Tcl_NewStringObj("unknown result",-1));
			   	return TCL_ERROR;
			}
		} else if (strncasecmp(what,"-convert_functions",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_CONVERT_FUNCTIONS,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -convert_functions",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_FN_CVT_CAST) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("cvt_cast",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_CVT_CONVERT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("cvt_convert",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-convert",8) == 0) {
			SQLUSMALLINT convtype;
			if (strncasecmp(what,"-convert_bigint",strlen(what)) == 0) {
				convtype = SQL_CONVERT_BIGINT;
   			} else if (strncasecmp(what,"-convert_binary",strlen(what)) == 0) {
   				convtype = SQL_CONVERT_BINARY;
   			} else if (strncasecmp(what,"-convert_bit",strlen(what)) == 0) {
   				convtype = SQL_CONVERT_BIT;
   			} else if (strncasecmp(what,"-convert_char",strlen(what)) == 0) {
   				convtype = SQL_CONVERT_CHAR;
#ifdef SQL_CONVERT_GUID
   			} else if (strncasecmp(what,"-convert_guid",strlen(what)) == 0) {
   				convtype = SQL_CONVERT_GUID;
#endif
   			} else if (strncasecmp(what,"-convert_date",strlen(what)) == 0) {
   				convtype = SQL_CONVERT_DATE;
   			} else if (strncasecmp(what,"-convert_decimal",strlen(what)) == 0) {
   				convtype = SQL_CONVERT_DECIMAL;
   			} else if (strncasecmp(what,"-convert_double",strlen(what)) == 0) {
   				convtype = SQL_CONVERT_DOUBLE;
   			} else if (strncasecmp(what,"-convert_float",strlen(what)) == 0) {
   				convtype = SQL_CONVERT_FLOAT;
   			} else if (strncasecmp(what,"-convert_integer",strlen(what)) == 0) {
   				convtype = SQL_CONVERT_INTEGER;
   			} else if (strncasecmp(what,"-convert_interval_year_month",strlen(what)) == 0) {
   				convtype = SQL_CONVERT_INTERVAL_YEAR_MONTH;
   			} else if (strncasecmp(what,"-convert_interval_day_time",strlen(what)) == 0) {
   				convtype = SQL_CONVERT_INTERVAL_DAY_TIME;
   			} else if (strncasecmp(what,"-convert_longvarbinary",strlen(what)) == 0) {
   				convtype = SQL_CONVERT_LONGVARBINARY;
   			} else if (strncasecmp(what,"-convert_longvarchar",strlen(what)) == 0) {
   				convtype = SQL_CONVERT_LONGVARCHAR;
   			} else if (strncasecmp(what,"-convert_numeric",strlen(what)) == 0) {
   				convtype = SQL_CONVERT_NUMERIC;
   			} else if (strncasecmp(what,"-convert_real",strlen(what)) == 0) {
   				convtype = SQL_CONVERT_REAL;
   			} else if (strncasecmp(what,"-convert_smallint",strlen(what)) == 0) {
   				convtype = SQL_CONVERT_SMALLINT;
   			} else if (strncasecmp(what,"-convert_time",strlen(what)) == 0) {
   				convtype = SQL_CONVERT_TIME;
   			} else if (strncasecmp(what,"-convert_timestamp",strlen(what)) == 0) {
   				convtype = SQL_CONVERT_TIMESTAMP;
   			} else if (strncasecmp(what,"-convert_tinyint",strlen(what)) == 0) {
   				convtype = SQL_CONVERT_TINYINT;
   			} else if (strncasecmp(what,"-convert_varbinary",strlen(what)) == 0) {
   				convtype = SQL_CONVERT_VARBINARY;
   			} else if (strncasecmp(what,"-convert_varchar",strlen(what)) == 0) {
   				convtype = SQL_CONVERT_VARCHAR;
			} else {
				Tcl_SetObjResult(interp,Tcl_NewStringObj("unspecificed conversion",-1));
				return TCL_ERROR;
			}
			ret = SQLGetInfo(self->dbc,convtype,(SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -convert",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_CVT_BIGINT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("bigint",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CVT_BINARY) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("binary",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CVT_BIT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("bit",-1)) == TCL_ERROR) return TCL_ERROR;
			}
#ifdef SQL_CVT_GUID
			if ((tempint & SQL_CVT_GUID) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("guid",-1)) == TCL_ERROR) return TCL_ERROR;
			}
#endif
			if ((tempint & SQL_CVT_CHAR) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("char",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CVT_DATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("date",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CVT_DECIMAL) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("decimal",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CVT_DOUBLE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("double",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CVT_FLOAT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("float",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CVT_INTEGER) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("integer",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CVT_INTERVAL_YEAR_MONTH) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("interval_year_month",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CVT_INTERVAL_DAY_TIME) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("interval_day_time",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CVT_LONGVARBINARY) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("longvarbinary",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CVT_LONGVARCHAR) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("longvarchar",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CVT_NUMERIC) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("numeric",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CVT_REAL) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("real",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CVT_SMALLINT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("smallint",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CVT_TIME) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("time",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CVT_TIMESTAMP) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("timestamp",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CVT_TINYINT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("tinyint",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CVT_VARBINARY) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("varbinary",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CVT_VARCHAR) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("varchar",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-correlation_name",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_CORRELATION_NAME,
				   (SQLPOINTER)&tempsmallint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -correlation_name",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			switch (tempsmallint) {
			    case SQL_CN_NONE:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("none",-1));
				return TCL_OK;
			    case SQL_CN_DIFFERENT:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("different",-1));
				return TCL_OK;
			    case SQL_CN_ANY:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("any",-1));
				return TCL_OK;
			    default:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("unknown result",-1));
				return TCL_ERROR;
			}
		} else if (strncasecmp(what,"-create_assertion",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_CREATE_ASSERTION,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -create_assertion",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_CA_CREATE_ASSERTION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("create_assertion",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA_CONSTRAINT_INITIALLY_DEFERRED) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("constraint_initially_deferred",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA_CONSTRAINT_INITIALLY_IMMEDIATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("constraint_initially_immediate",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA_CONSTRAINT_DEFERRABLE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("constraint_deferrable",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA_CONSTRAINT_NON_DEFERRABLE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("constraint_non_deferrable",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-create_character_set",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_CREATE_CHARACTER_SET,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -create_character_set",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_CCS_CREATE_CHARACTER_SET) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("create_character_set",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CCS_COLLATE_CLAUSE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("collate_clause",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CCS_LIMITED_COLLATION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("limited_collation",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-create_collation",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_CREATE_COLLATION,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -create_collation",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_CCOL_CREATE_COLLATION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("create_collation",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-create_domain",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_CREATE_DOMAIN,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -create_domain",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_CDO_CREATE_DOMAIN) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("create_domain",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CDO_CONSTRAINT_NAME_DEFINITION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("constraint_name_definition",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CDO_DEFAULT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("default",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CDO_CONSTRAINT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("constraint",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CDO_COLLATION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("collation",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CDO_CONSTRAINT_INITIALLY_DEFERRED) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("constraint_initially_deferred",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CDO_CONSTRAINT_INITIALLY_IMMEDIATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("constraint_initially_immediate",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CDO_CONSTRAINT_DEFERRABLE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("constraint_deferrable",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CDO_CONSTRAINT_NON_DEFERRABLE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("constraint_non_deferrable",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-create_schema",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_CREATE_SCHEMA,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -create_schema",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_CS_CREATE_SCHEMA) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("create_schema",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CS_AUTHORIZATION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("authorization",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CS_DEFAULT_CHARACTER_SET) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("default_character_set",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-create_table",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_CREATE_TABLE,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -create_table",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_CT_CREATE_TABLE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("create_table",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CT_TABLE_CONSTRAINT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("table_constraint",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CT_CONSTRAINT_NAME_DEFINITION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("constraint_name_definition",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CT_COMMIT_PRESERVE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("commit_preserve",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CT_COMMIT_DELETE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("commit_delete",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CT_GLOBAL_TEMPORARY) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("global_temporary",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CT_LOCAL_TEMPORARY) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("local_temporary",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CT_COLUMN_CONSTRAINT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("column_constraint",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CT_COLUMN_DEFAULT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("column_default",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CT_COLUMN_COLLATION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("column_collation",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CT_CONSTRAINT_INITIALLY_DEFERRED) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("constraint_initially_deferred",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CT_CONSTRAINT_INITIALLY_IMMEDIATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("constraint_initially_immediate",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CT_CONSTRAINT_DEFERRABLE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("constraint_deferrable",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CT_CONSTRAINT_NON_DEFERRABLE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("constraint_non_deferrable",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-create_translation",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_CREATE_TRANSLATION,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -create_translation",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_CTR_CREATE_TRANSLATION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("create_translation",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-create_view",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_CREATE_VIEW,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -create_view",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_CV_CREATE_VIEW) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("create_view",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CV_CHECK_OPTION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("check_option",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CV_CASCADED) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("cascaded",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CV_LOCAL) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("local",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-cursor_commit_behavior",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_CURSOR_COMMIT_BEHAVIOR,
				   (SQLPOINTER)&tempsmallint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -cursor_commit_behavior",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			switch (tempsmallint) {
			    case SQL_CB_DELETE:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("delete",-1));
				return TCL_OK;
			    case SQL_CB_CLOSE:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("close",-1));
				return TCL_OK;
			    case SQL_CB_PRESERVE:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("preserve",-1));
				return TCL_OK;
			    default:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("unknown result",-1));
				return TCL_ERROR;
			}
		} else if (strncasecmp(what,"-cursor_rollback_behavior",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_CURSOR_ROLLBACK_BEHAVIOR,
				   (SQLPOINTER)&tempsmallint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -cursor_rollback_behavior",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			switch (tempsmallint) {
			    case SQL_CB_DELETE:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("delete",-1));
				return TCL_OK;
			    case SQL_CB_CLOSE:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("close",-1));
				return TCL_OK;
			    case SQL_CB_PRESERVE:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("preserve",-1));
				return TCL_OK;
			    default:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("unknown result",-1));
				return TCL_ERROR;
			}
#ifdef SQL_CURSOR_ROLLBACK_SQL_CURSOR_SENSITIVITY
		} else if (strncasecmp(what,"-cursor_rollback_sql_cursor_sensitivity",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_CURSOR_ROLLBACK_SQL_CURSOR_SENSITIVITY,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -cursor_rollback_sql_cursor_sensitivity",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			switch (tempint) {
			    case SQL_INSENSITIVE:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("insensitive",-1));
				return TCL_OK;
			    case SQL_UNSPECIFIED:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("unspecified",-1));
				return TCL_OK;
			    case SQL_SENSITIVE:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("sensitive",-1));
				return TCL_OK;
			    default:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("unknown result",-1));
				return TCL_ERROR;
			}
#endif
		} else if (strncasecmp(what,"-data_source_name",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_DATA_SOURCE_NAME,
				   (SQLPOINTER)tempstring,sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -data_source_name",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewStringObj(tempstring,-1));
			return TCL_OK;
		} else if (strncasecmp(what,"-data_source_read_only",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_DATA_SOURCE_READ_ONLY,
				   (SQLPOINTER)tempstring,sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -data_source_read_only",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			if (strcasecmp(tempstring,"Y") == 0)
				Tcl_SetObjResult(interp,Tcl_NewBooleanObj(1));
			else	Tcl_SetObjResult(interp,Tcl_NewBooleanObj(0));
			return TCL_OK;
		} else if (strncasecmp(what,"-database_name",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_DATABASE_NAME,
				   (SQLPOINTER)tempstring,sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -database_name",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewStringObj(tempstring,-1));
			return TCL_OK;
		} else if (strncasecmp(what,"-datetime_literals",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_DATETIME_LITERALS,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -datetime_literals",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_DL_SQL92_DATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sql92_date",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_DL_SQL92_TIME) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sql92_time",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_DL_SQL92_TIMESTAMP) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sql92_timestamp",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_DL_SQL92_INTERVAL_YEAR) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sql92_interval_year",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_DL_SQL92_INTERVAL_MONTH) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sql92_interval_month",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_DL_SQL92_INTERVAL_DAY) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sql92_interval_day",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_DL_SQL92_INTERVAL_HOUR) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sql92_interval_hour",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_DL_SQL92_INTERVAL_MINUTE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sql92_interval_minute",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_DL_SQL92_INTERVAL_SECOND) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sql92_interval_second",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_DL_SQL92_INTERVAL_YEAR_TO_MONTH) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sql92_interval_year_to_month",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_DL_SQL92_INTERVAL_DAY_TO_HOUR) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sql92_interval_day_to_hour",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_DL_SQL92_INTERVAL_DAY_TO_MINUTE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sql92_interval_day_to_minute",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_DL_SQL92_INTERVAL_DAY_TO_SECOND) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sql92_interval_day_to_second",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_DL_SQL92_INTERVAL_HOUR_TO_MINUTE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sql92_interval_hour_to_minute",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_DL_SQL92_INTERVAL_HOUR_TO_SECOND) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sql92_interval_hour_to_second",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_DL_SQL92_INTERVAL_MINUTE_TO_SECOND) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sql92_interval_minute_to_second",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-dbms_name",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc, SQL_DBMS_NAME, (SQLPOINTER)tempstring,
				   sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -dbms_name",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj  *result = Tcl_NewStringObj(tempstring,-1);
			Tcl_SetObjResult(interp,result);
			return TCL_OK;
		} else if (strncasecmp(what,"-dbms_ver",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc, SQL_DBMS_VER, (SQLPOINTER)tempstring,
				   sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -dbms_ver",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj  *result = Tcl_NewStringObj(tempstring,-1);
			Tcl_SetObjResult(interp,result);
			return TCL_OK;
		} else if (strncasecmp(what,"-ddl_index",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_DDL_INDEX,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -ddl_index",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_DI_CREATE_INDEX) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("create_index",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_DI_DROP_INDEX) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("drop_index",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-default_txn_isolation",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_DEFAULT_TXN_ISOLATION,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -default_txn_isolation",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_TXN_READ_UNCOMMITTED) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("read_uncommitted",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_TXN_READ_COMMITTED) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("read_committed",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_TXN_REPEATABLE_READ) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("repeatable_read",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_TXN_SERIALIZABLE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("serializable",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-describe_parameter",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_DESCRIBE_PARAMETER,
				   (SQLPOINTER)tempstring,sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -describe_parameter",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			if (strcasecmp(tempstring,"Y") == 0)
				Tcl_SetObjResult(interp,Tcl_NewBooleanObj(1));
			else	Tcl_SetObjResult(interp,Tcl_NewBooleanObj(0));
			return TCL_OK;
		} else if (strncasecmp(what,"-dm_ver",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_DM_VER,
				   (SQLPOINTER)tempstring,
				   sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -dm_ver",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj  *result = Tcl_NewStringObj(tempstring,-1);
			Tcl_SetObjResult(interp,result);
			return TCL_OK;
		} else if (strncasecmp(what,"-driver_name",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_DRIVER_NAME,
				   (SQLPOINTER)tempstring,
				   sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -driver_name",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj  *result = Tcl_NewStringObj(tempstring,-1);
			Tcl_SetObjResult(interp,result);
			return TCL_OK;
		} else if (strncasecmp(what,"-driver_odbc_ver",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_DRIVER_ODBC_VER,
				   (SQLPOINTER)tempstring,
				   sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -driver_odbc_ver",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj  *result = Tcl_NewStringObj(tempstring,-1);
			Tcl_SetObjResult(interp,result);
			return TCL_OK;
		} else if (strncasecmp(what,"-driver_ver",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_DRIVER_VER,
				   (SQLPOINTER)tempstring,
				   sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -driver_ver",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj  *result = Tcl_NewStringObj(tempstring,-1);
			Tcl_SetObjResult(interp,result);
			return TCL_OK;
		} else if (strncasecmp(what,"-drop_assertion",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_DROP_ASSERTION,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -drop_assertion",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_DA_DROP_ASSERTION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("drop_assertion",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-drop_character_set",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_DROP_CHARACTER_SET,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -drop_character_set",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_DCS_DROP_CHARACTER_SET) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("drop_character_set",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-drop_collation",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_DROP_COLLATION,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -drop_collation",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_DC_DROP_COLLATION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("drop_collation",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-drop_domain",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_DROP_DOMAIN,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -drop_domain",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_DD_DROP_DOMAIN) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("drop_domain",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_DD_CASCADE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("cascade",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_DD_RESTRICT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("restrict",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-drop_schema",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_DROP_SCHEMA,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -drop_schema",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_DS_DROP_SCHEMA) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("drop_schema",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_DS_CASCADE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("cascade",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_DS_RESTRICT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("restrict",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-drop_table",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_DROP_TABLE,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -drop_table",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_DT_DROP_TABLE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("drop_table",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_DT_CASCADE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("cascade",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_DT_RESTRICT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("restrict",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-drop_translation",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_DROP_TRANSLATION,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -drop_translation",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_DTR_DROP_TRANSLATION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("drop_translation",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-drop_view",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_DROP_VIEW,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -drop_view",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_DV_DROP_VIEW) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("drop_view",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_DV_CASCADE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("cascade",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_DV_RESTRICT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("restrict",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-dynamic_cursor_attributes",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_DYNAMIC_CURSOR_ATTRIBUTES1,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -dynamic_cursor_attributes",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_CA1_NEXT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("next",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_ABSOLUTE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("absolute",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_RELATIVE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("relative",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_BOOKMARK) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("bookmark",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_LOCK_EXCLUSIVE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("lock_exclusive",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_LOCK_NO_CHANGE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("lock_no_change",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_LOCK_UNLOCK) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("lock_unlock",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_POS_POSITION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("pos_position",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_POS_UPDATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("pos_update",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_POS_DELETE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("pos_delete",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_POS_REFRESH) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("pos_refresh",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_POSITIONED_UPDATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("positioned_update",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_POSITIONED_DELETE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("positioned_delete",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_SELECT_FOR_UPDATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("select_for_update",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_BULK_ADD) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("bulk_add",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_BULK_UPDATE_BY_BOOKMARK) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("bulk_update_by_bookmark",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_BULK_DELETE_BY_BOOKMARK) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("bulk_delete_by_bookmark",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_BULK_FETCH_BY_BOOKMARK) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("bulk_fetch_by_bookmark",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			ret = SQLGetInfo(self->dbc,SQL_DYNAMIC_CURSOR_ATTRIBUTES2,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -dynamic_cursor_attributes",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_READ_ONLY_CONCURRENCY) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("read_only_concurrency",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_LOCK_CONCURRENCY) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("lock_concurrency",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_OPT_ROWVER_CONCURRENCY) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("opt_rowver_concurrency",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_OPT_VALUES_CONCURRENCY) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("opt_values_concurrency",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_SENSITIVITY_ADDITIONS) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sensitivity_additions",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_SENSITIVITY_DELETIONS) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sensitivity_deletions",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_SENSITIVITY_UPDATES) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sensitivity_updates",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_MAX_ROWS_SELECT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("max_rows_select",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_MAX_ROWS_INSERT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("max_rows_insert",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_MAX_ROWS_DELETE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("max_rows_delete",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_MAX_ROWS_UPDATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("max_rows_update",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_MAX_ROWS_CATALOG) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("max_rows_catalog",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_MAX_ROWS_AFFECTS_ALL) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("max_rows_affects_all",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_CRC_EXACT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("crc_exact",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_CRC_APPROXIMATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("crc_approximate",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_SIMULATE_NON_UNIQUE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("simulate_non_unique",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_SIMULATE_TRY_UNIQUE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("simulate_try_unique",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_SIMULATE_UNIQUE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("simulate_unique",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-expressions_in_orderby",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_EXPRESSIONS_IN_ORDERBY,
				   (SQLPOINTER)tempstring,sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -expressions_in_orderby",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			if (strcasecmp(tempstring,"Y") == 0)
				Tcl_SetObjResult(interp,Tcl_NewBooleanObj(1));
			else	Tcl_SetObjResult(interp,Tcl_NewBooleanObj(0));
			return TCL_OK;
		} else if (strncasecmp(what,"-file_usage",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_FILE_USAGE,
				   (SQLPOINTER)&tempsmallint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -file_usage",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			switch (tempsmallint) {
			    case SQL_FILE_NOT_SUPPORTED:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("file_not_supported",-1));
				return TCL_OK;
			    case SQL_FILE_TABLE:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("file_table",-1));
				return TCL_OK;
			    case SQL_FILE_CATALOG:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("file_catalog",-1));
				return TCL_OK;
			    default:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("unknown result",-1));
				return TCL_ERROR;
			}
		} else if (strncasecmp(what,"-forward_only_cursor_attributes",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_FORWARD_ONLY_CURSOR_ATTRIBUTES1,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -forward_only_cursor_attributes",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_CA1_NEXT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("next",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_LOCK_EXCLUSIVE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("lock_exclusive",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_LOCK_NO_CHANGE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("lock_no_change",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_LOCK_UNLOCK) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("lock_unlock",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_POS_POSITION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("pos_position",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_POS_UPDATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("pos_update",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_POS_DELETE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("pos_delete",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_POS_REFRESH) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("pos_refresh",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_POSITIONED_UPDATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("positioned_update",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_POSITIONED_DELETE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("positioned_delete",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_SELECT_FOR_UPDATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("select_for_update",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_BULK_ADD) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("bulk_add",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_BULK_UPDATE_BY_BOOKMARK) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("bulk_update_by_bookmark",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_BULK_DELETE_BY_BOOKMARK) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("bulk_delete_by_bookmark",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_BULK_FETCH_BY_BOOKMARK) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("bulk_fetch_by_bookmark",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			ret = SQLGetInfo(self->dbc,SQL_FORWARD_ONLY_CURSOR_ATTRIBUTES2,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -forward_only_cursor_attributes",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_READ_ONLY_CONCURRENCY) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("read_only_concurrency",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_LOCK_CONCURRENCY) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("lock_concurrency",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_OPT_ROWVER_CONCURRENCY) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("opt_rowver_concurrency",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_OPT_VALUES_CONCURRENCY) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("opt_values_concurrency",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_SENSITIVITY_ADDITIONS) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sensitivity_additions",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_SENSITIVITY_DELETIONS) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sensitivity_deletions",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_SENSITIVITY_UPDATES) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sensitivity_updates",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_MAX_ROWS_SELECT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("max_rows_select",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_MAX_ROWS_INSERT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("max_rows_insert",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_MAX_ROWS_DELETE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("max_rows_delete",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_MAX_ROWS_UPDATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("max_rows_update",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_MAX_ROWS_CATALOG) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("max_rows_catalog",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_MAX_ROWS_AFFECTS_ALL) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("max_rows_affects_all",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_CRC_EXACT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("crc_exact",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_CRC_APPROXIMATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("crc_approximate",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_SIMULATE_NON_UNIQUE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("simulate_non_unique",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_SIMULATE_TRY_UNIQUE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("simulate_try_unique",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_SIMULATE_UNIQUE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("simulate_unique",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-getdata_extensions",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_GETDATA_EXTENSIONS,
				(SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -getdata_extensions",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_GD_ANY_COLUMN) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("any_column",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_GD_ANY_ORDER) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("any_order",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_GD_BLOCK) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("block",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_GD_BOUND) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("bound",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-group_by",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_GROUP_BY,
				   (SQLPOINTER)&tempsmallint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -group_by",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			switch (tempsmallint) {
			    case SQL_GB_COLLATE:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("collate",-1));
				return TCL_OK;
			    case SQL_GB_NOT_SUPPORTED:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("not_supported",-1));
				return TCL_OK;
			    case SQL_GB_GROUP_BY_EQUALS_SELECT:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("group_by_equals_select",-1));
				return TCL_OK;
			    case SQL_GB_GROUP_BY_CONTAINS_SELECT:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("group_by_contains_select",-1));
				return TCL_OK;
			    case SQL_GB_NO_RELATION:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("no_relation",-1));
				return TCL_OK;
			    default:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("unknown result",-1));
				return TCL_ERROR;
			}
		} else if (strncasecmp(what,"-identifier_case",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_IDENTIFIER_CASE,
				   (SQLPOINTER)&tempsmallint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -identifier_case",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			switch (tempsmallint) {
			    case SQL_IC_UPPER:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("upper",-1));
				return TCL_OK;
			    case SQL_IC_LOWER:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("lower",-1));
				return TCL_OK;
			    case SQL_IC_SENSITIVE:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("sensitive",-1));
				return TCL_OK;
			    case SQL_IC_MIXED:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("mixed",-1));
				return TCL_OK;
			    default:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("unknown result",-1));
				return TCL_ERROR;
			}
		} else if (strncasecmp(what,"-identifier_quote_char",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_IDENTIFIER_QUOTE_CHAR,
				   (SQLPOINTER)tempstring,
				   sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -identifier_quote_char",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj  *result = Tcl_NewStringObj(tempstring,-1);
			Tcl_SetObjResult(interp,result);
			return TCL_OK;
		} else if (strncasecmp(what,"-index_keywords",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_INDEX_KEYWORDS,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -index_keywords",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_IK_NONE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("none",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_IK_ASC) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("asc",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_IK_DESC) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("desc",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_IK_ALL) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("all",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-info_schema_views",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_INFO_SCHEMA_VIEWS,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -info_schema_views",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_ISV_ASSERTIONS) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("assertions",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_ISV_CHARACTER_SETS) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("character_sets",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_ISV_CHECK_CONSTRAINTS) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("check_constraints",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_ISV_COLLATIONS) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("collations",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_ISV_COLUMN_DOMAIN_USAGE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("column_domain_usage",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_ISV_COLUMN_PRIVILEGES) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("column_privileges",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_ISV_COLUMNS) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("columns",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_ISV_CONSTRAINT_COLUMN_USAGE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("constraint_column_usage",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_ISV_CONSTRAINT_TABLE_USAGE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("constraint_table_usage",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_ISV_DOMAIN_CONSTRAINTS) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("domain_constraints",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_ISV_DOMAINS) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("domains",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_ISV_KEY_COLUMN_USAGE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("key_column_usage",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_ISV_REFERENTIAL_CONSTRAINTS) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("referential_constraints",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_ISV_SCHEMATA) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("schemata",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_ISV_SQL_LANGUAGES) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sql_languages",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_ISV_TABLE_CONSTRAINTS) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("table_constraints",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_ISV_TABLE_PRIVILEGES) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("table_privileges",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_ISV_TABLES) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("tables",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_ISV_TRANSLATIONS) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("translations",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_ISV_USAGE_PRIVILEGES) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("usage_privileges",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_ISV_VIEW_COLUMN_USAGE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("view_column_usage",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_ISV_VIEW_TABLE_USAGE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("view_table_usage",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_ISV_VIEWS) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("views",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-insert_statement",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_INSERT_STATEMENT,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -insert_statement",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_IS_INSERT_LITERALS) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("insert_literals",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_IS_INSERT_SEARCHED) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("insert_searched",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_IS_SELECT_INTO) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("select_into",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-integrity",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_INTEGRITY,
				   (SQLPOINTER)tempstring,
                                   sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -integrity",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			if (strcasecmp(tempstring,"Y") == 0)
				Tcl_SetObjResult(interp,Tcl_NewBooleanObj(1));
			else	Tcl_SetObjResult(interp,Tcl_NewBooleanObj(0));
			return TCL_OK;
		} else if (strncasecmp(what,"-keyset_cursor_attributes",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_KEYSET_CURSOR_ATTRIBUTES1,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -keyset_cursor_attributes",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_CA1_NEXT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("next",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_ABSOLUTE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("absolute",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_RELATIVE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("relative",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_BOOKMARK) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("bookmark",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_LOCK_EXCLUSIVE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("lock_exclusive",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_LOCK_NO_CHANGE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("lock_no_change",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_LOCK_UNLOCK) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("lock_unlock",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_POS_POSITION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("pos_position",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_POS_UPDATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("pos_update",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_POS_DELETE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("pos_delete",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_POS_REFRESH) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("pos_refresh",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_POSITIONED_UPDATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("positioned_update",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_POSITIONED_DELETE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("positioned_delete",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_SELECT_FOR_UPDATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("select_for_update",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_BULK_ADD) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("bulk_add",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_BULK_UPDATE_BY_BOOKMARK) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("bulk_update_by_bookmark",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_BULK_DELETE_BY_BOOKMARK) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("bulk_delete_by_bookmark",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_BULK_FETCH_BY_BOOKMARK) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("bulk_fetch_by_bookmark",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			ret = SQLGetInfo(self->dbc,SQL_KEYSET_CURSOR_ATTRIBUTES2,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget keyset_cursor_attributes",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_READ_ONLY_CONCURRENCY) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("read_only_concurrency",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_LOCK_CONCURRENCY) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("lock_concurrency",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_OPT_ROWVER_CONCURRENCY) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("opt_rowver_concurrency",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_OPT_VALUES_CONCURRENCY) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("opt_values_concurrency",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_SENSITIVITY_ADDITIONS) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sensitivity_additions",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_SENSITIVITY_DELETIONS) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sensitivity_deletions",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_SENSITIVITY_UPDATES) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sensitivity_updates",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_MAX_ROWS_SELECT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("max_rows_select",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_MAX_ROWS_INSERT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("max_rows_insert",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_MAX_ROWS_DELETE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("max_rows_delete",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_MAX_ROWS_UPDATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("max_rows_update",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_MAX_ROWS_CATALOG) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("max_rows_catalog",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_MAX_ROWS_AFFECTS_ALL) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("max_rows_affects_all",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_CRC_EXACT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("crc_exact",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_CRC_APPROXIMATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("crc_approximate",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_SIMULATE_NON_UNIQUE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("simulate_non_unique",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_SIMULATE_TRY_UNIQUE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("simulate_try_unique",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_SIMULATE_UNIQUE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("simulate_unique",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-keywords",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_KEYWORDS,
				   (SQLPOINTER)tempstring,
				   sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -keywords",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj  *result = Tcl_NewStringObj(tempstring,-1);
			Tcl_SetObjResult(interp,result);
			return TCL_OK;
		} else if (strncasecmp(what,"-like_escape_clause",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_LIKE_ESCAPE_CLAUSE,
				   (SQLPOINTER)tempstring,sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -like_escape_clause",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			if (strcasecmp(tempstring,"Y") == 0)
				Tcl_SetObjResult(interp,Tcl_NewBooleanObj(1));
			else	Tcl_SetObjResult(interp,Tcl_NewBooleanObj(0));
			return TCL_OK;
		} else if (strncasecmp(what,"-max_async_concurrent_statements",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_MAX_ASYNC_CONCURRENT_STATEMENTS,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -max_async_concurrent_statements",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewLongObj(tempint));
			return TCL_OK;
		} else if (strncasecmp(what,"-max_binary_literal_len",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_MAX_BINARY_LITERAL_LEN,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -max_binary_literal_len",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewLongObj(tempint));
			return TCL_OK;
		} else if (strncasecmp(what,"-max_catalog_name_len",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_MAX_CATALOG_NAME_LEN,
				   (SQLPOINTER)&tempsmallint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -max_catalog_name_len",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewIntObj(tempsmallint));
			return TCL_OK;
		} else if (strncasecmp(what,"-max_char_literal_len",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_MAX_CHAR_LITERAL_LEN,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -max_char_literal_len",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewLongObj(tempint));
			return TCL_OK;
		} else if (strncasecmp(what,"-max_column_name_len",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_MAX_COLUMN_NAME_LEN,
				   (SQLPOINTER)&tempsmallint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -max_column_name_len",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewIntObj(tempsmallint));
			return TCL_OK;
		} else if (strncasecmp(what,"-max_columns_in_group_by",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_MAX_COLUMNS_IN_GROUP_BY,
				   (SQLPOINTER)&tempsmallint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -max_columns_in_group_by",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewIntObj(tempsmallint));
			return TCL_OK;
		} else if (strncasecmp(what,"-max_columns_in_index",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_MAX_COLUMNS_IN_INDEX,
				   (SQLPOINTER)&tempsmallint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -max_columns_in_index",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewIntObj(tempsmallint));
			return TCL_OK;
		} else if (strncasecmp(what,"-max_columns_in_order_by",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_MAX_COLUMNS_IN_ORDER_BY,
				   (SQLPOINTER)&tempsmallint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -max_columns_in_order_by",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewIntObj(tempsmallint));
			return TCL_OK;
		} else if (strncasecmp(what,"-max_columns_in_select",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_MAX_COLUMNS_IN_SELECT,
				   (SQLPOINTER)&tempsmallint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -max_columns_in_select",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewIntObj(tempsmallint));
			return TCL_OK;
		} else if (strncasecmp(what,"-max_columns_in_table",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_MAX_COLUMNS_IN_TABLE,
				   (SQLPOINTER)&tempsmallint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -max_columns_in_table",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewIntObj(tempsmallint));
			return TCL_OK;
		} else if (strncasecmp(what,"-max_concurrent_activities",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_MAX_CONCURRENT_ACTIVITIES,
				   &tempsmallint, 0, 0);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -max_concurrent_activities",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewIntObj(tempsmallint));
			return TCL_OK;
		} else if (strncasecmp(what,"-max_cursor_name_len",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_MAX_CURSOR_NAME_LEN,
				   (SQLPOINTER)&tempsmallint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -max_cursor_name_len",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewIntObj(tempsmallint));
			return TCL_OK;
		} else if (strncasecmp(what,"-max_driver_connections",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_MAX_DRIVER_CONNECTIONS,
				   (SQLPOINTER)&tempsmallint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -max_driver_connections",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewIntObj(tempsmallint));
			return TCL_OK;
		} else if (strncasecmp(what,"-max_identifier_len",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_MAX_IDENTIFIER_LEN,
				   (SQLPOINTER)&tempsmallint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -max_identifier_len",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewIntObj(tempsmallint));
			return TCL_OK;
		} else if (strncasecmp(what,"-max_index_size",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_MAX_INDEX_SIZE,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -max_index_size",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewLongObj(tempint));
			return TCL_OK;
		} else if (strncasecmp(what,"-max_procedure_name_len",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_MAX_PROCEDURE_NAME_LEN,
				   (SQLPOINTER)&tempsmallint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -max_procedure_name_len",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewIntObj(tempsmallint));
			return TCL_OK;
		} else if (strncasecmp(what,"-max_row_size_includes_long",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_MAX_ROW_SIZE_INCLUDES_LONG,
				   (SQLPOINTER)tempstring,sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -max_row_size_includes_long",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			if (strcasecmp(tempstring,"Y") == 0)
				Tcl_SetObjResult(interp,Tcl_NewBooleanObj(1));
			else	Tcl_SetObjResult(interp,Tcl_NewBooleanObj(0));
			return TCL_OK;
		} else if (strncasecmp(what,"-max_row_size",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_MAX_ROW_SIZE,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -max_row_size",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewLongObj(tempint));
			return TCL_OK;
		} else if (strncasecmp(what,"-max_schema_name_len",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_MAX_SCHEMA_NAME_LEN,
				   (SQLPOINTER)&tempsmallint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -max_schema_name_len",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewIntObj(tempsmallint));
			return TCL_OK;
		} else if (strncasecmp(what,"-max_statement_len",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_MAX_STATEMENT_LEN,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -max_statement_len",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewLongObj(tempint));
			return TCL_OK;
		} else if (strncasecmp(what,"-max_table_name_len",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_MAX_TABLE_NAME_LEN,
				   (SQLPOINTER)&tempsmallint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -max_table_name_len",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewIntObj(tempsmallint));
			return TCL_OK;
		} else if (strncasecmp(what,"-max_tables_in_select",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_MAX_TABLES_IN_SELECT,
				   (SQLPOINTER)&tempsmallint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -max_tables_in_select",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewIntObj(tempsmallint));
			return TCL_OK;
		} else if (strncasecmp(what,"-max_user_name_len",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_MAX_USER_NAME_LEN,
				   (SQLPOINTER)&tempsmallint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -max_user_name_len",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewIntObj(tempsmallint));
			return TCL_OK;
		} else if (strncasecmp(what,"-mult_result_sets",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_MULT_RESULT_SETS,
				   (SQLPOINTER)tempstring,sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -mult_result_sets",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			if (strcasecmp(tempstring,"Y") == 0)
				Tcl_SetObjResult(interp,Tcl_NewBooleanObj(1));
			else	Tcl_SetObjResult(interp,Tcl_NewBooleanObj(0));
			return TCL_OK;
		} else if (strncasecmp(what,"-multiple_active_txn",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_MULTIPLE_ACTIVE_TXN,
				   (SQLPOINTER)tempstring,sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -multiple_active_txn",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			if (strcasecmp(tempstring,"Y") == 0)
				Tcl_SetObjResult(interp,Tcl_NewBooleanObj(1));
			else	Tcl_SetObjResult(interp,Tcl_NewBooleanObj(0));
			return TCL_OK;
		} else if (strncasecmp(what,"-need_long_data_len",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_NEED_LONG_DATA_LEN,
				   (SQLPOINTER)tempstring,sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -need_long_data_len",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			if (strcasecmp(tempstring,"Y") == 0)
				Tcl_SetObjResult(interp,Tcl_NewBooleanObj(1));
			else	Tcl_SetObjResult(interp,Tcl_NewBooleanObj(0));
			return TCL_OK;
		} else if (strncasecmp(what,"-non_nullable_columns",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_NON_NULLABLE_COLUMNS,
				   (SQLPOINTER)&tempsmallint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -non_nullable_columns",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			switch (tempsmallint) {
			    case SQL_NNC_NULL:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("null",-1));
				return TCL_OK;
			    case SQL_NNC_NON_NULL:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("non_null",-1));
				return TCL_OK;
			    default:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("unknown result",-1));
				return TCL_ERROR;
			}
		} else if (strncasecmp(what,"-null_collation",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_NULL_COLLATION,
				   (SQLPOINTER)&tempsmallint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -null_collation",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			switch (tempsmallint) {
			    case SQL_NC_END:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("end",-1));
				return TCL_OK;
			    case SQL_NC_HIGH:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("high",-1));
				return TCL_OK;
			    case SQL_NC_LOW:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("low",-1));
				return TCL_OK;
			    case SQL_NC_START:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("start",-1));
				return TCL_OK;
			    default:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("unknown result",-1));
				return TCL_ERROR;
			}
		} else if (strncasecmp(what,"-numeric_functions",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_NUMERIC_FUNCTIONS,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -numeric_functions",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_FN_NUM_ABS) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("abs",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_NUM_ACOS) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("acos",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_NUM_ASIN) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("asin",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_NUM_ATAN) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("atan",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_NUM_ATAN2) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("atan2",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_NUM_CEILING) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("ceiling",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_NUM_COS) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("cos",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_NUM_COT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("cot",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_NUM_DEGREES) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("degrees",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_NUM_EXP) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("exp",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_NUM_FLOOR) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("floor",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_NUM_LOG) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("log",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_NUM_LOG10) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("log10",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_NUM_MOD) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("mod",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_NUM_PI) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("pi",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_NUM_POWER) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("power",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_NUM_RADIANS) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("radians",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_NUM_RAND) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("rand",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_NUM_ROUND) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("round",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_NUM_SIGN) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sign",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_NUM_SIN) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sin",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_NUM_SQRT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sqrt",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_NUM_TAN) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("tan",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_NUM_TRUNCATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("truncate",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-odbc_interface_conformance",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_ODBC_INTERFACE_CONFORMANCE,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -odbc_interface_conformance",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			switch (tempint) {
			    case SQL_OIC_CORE:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("core",-1));
				return TCL_OK;
			    case SQL_OIC_LEVEL1:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("level1",-1));
				return TCL_OK;
			    case SQL_OIC_LEVEL2:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("level2",-1));
				return TCL_OK;
			    default:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("unknown result",-1));
				return TCL_ERROR;
			}
		} else if (strncasecmp(what,"-odbc_ver",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_ODBC_VER,
				   (SQLPOINTER)tempstring,
				   sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -odbc_ver",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj  *result = Tcl_NewStringObj(tempstring,-1);
			Tcl_SetObjResult(interp,result);
			return TCL_OK;
		} else if (strncasecmp(what,"-oj_capabilities",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_OJ_CAPABILITIES,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -oj_capabilities",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_OJ_LEFT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("left",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_OJ_RIGHT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("right",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_OJ_FULL) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("full",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_OJ_NESTED) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("nested",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_OJ_NOT_ORDERED) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("not_ordered",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_OJ_INNER) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("inner",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_OJ_ALL_COMPARISON_OPS) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("all_comparison_ops",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-order_by_columns_in_select",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_ORDER_BY_COLUMNS_IN_SELECT,
				   (SQLPOINTER)tempstring,
                                   sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -order_by_columns_in_select",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			if (strcasecmp(tempstring,"Y") == 0)
				Tcl_SetObjResult(interp,Tcl_NewBooleanObj(1));
			else	Tcl_SetObjResult(interp,Tcl_NewBooleanObj(0));
			return TCL_OK;
		} else if (strncasecmp(what,"-param_array_row_counts",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_PARAM_ARRAY_ROW_COUNTS,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -param_array_row_counts",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			switch (tempint) {
			    case SQL_PARC_BATCH:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("batch",-1));
				return TCL_OK;
			    case SQL_PARC_NO_BATCH:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("no_batch",-1));
				return TCL_OK;
			    default:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("unknown result",-1));
				return TCL_ERROR;
			}
		} else if (strncasecmp(what,"-param_array_selects",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_PARAM_ARRAY_SELECTS,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -param_array_selects",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			switch (tempint) {
			    case SQL_PAS_BATCH:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("batch",-1));
				return TCL_OK;
			    case SQL_PAS_NO_BATCH:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("no_batch",-1));
				return TCL_OK;
			    case SQL_PAS_NO_SELECT:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("no_select",-1));
				return TCL_OK;
			    default:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("unknown result",-1));
				return TCL_ERROR;
			}
		} else if (strncasecmp(what,"-procedure_term",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_PROCEDURE_TERM,
				   (SQLPOINTER)tempstring,
				   sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -procedure_term",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj  *result = Tcl_NewStringObj(tempstring,-1);
			Tcl_SetObjResult(interp,result);
			return TCL_OK;
		} else if (strncasecmp(what,"-procedures",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_PROCEDURES,
				   (SQLPOINTER)tempstring,sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -procedures",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			if (strcasecmp(tempstring,"Y") == 0)
				Tcl_SetObjResult(interp,Tcl_NewBooleanObj(1));
			else	Tcl_SetObjResult(interp,Tcl_NewBooleanObj(0));
			return TCL_OK;
		} else if (strncasecmp(what,"-pos_operations",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_POS_OPERATIONS,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -pos_operations",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_POS_POSITION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("position",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_POS_REFRESH) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("refresh",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_POS_UPDATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("update",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_POS_DELETE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("delete",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_POS_ADD) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("add",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-quoted_identifier_case",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_QUOTED_IDENTIFIER_CASE,
				   (SQLPOINTER)&tempsmallint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -quoted_identifier_case",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			switch (tempsmallint) {
			    case SQL_IC_UPPER:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("upper",-1));
				return TCL_OK;
			    case SQL_IC_LOWER:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("lower",-1));
				return TCL_OK;
			    case SQL_IC_SENSITIVE:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("sensitive",-1));
				return TCL_OK;
			    case SQL_IC_MIXED:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("mixed",-1));
				return TCL_OK;
			    default:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("unknown result",-1));
				return TCL_ERROR;
			}
		} else if (strncasecmp(what,"-row_updates",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_ROW_UPDATES,
				   (SQLPOINTER)tempstring,
                                   sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -row_updates",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			if (strcasecmp(tempstring,"Y") == 0)
				Tcl_SetObjResult(interp,Tcl_NewBooleanObj(1));
			else	Tcl_SetObjResult(interp,Tcl_NewBooleanObj(0));
			return TCL_OK;
		} else if (strncasecmp(what,"-schema_term",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_SCHEMA_TERM,
				   (SQLPOINTER)tempstring,
				   sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -schema_term",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj  *result = Tcl_NewStringObj(tempstring,-1);
			Tcl_SetObjResult(interp,result);
			return TCL_OK;
		} else if (strncasecmp(what,"-schema_usage",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_SCHEMA_USAGE,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -schema_usage",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_SU_DML_STATEMENTS) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("dml_statements",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SU_PROCEDURE_INVOCATION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("procedure_invocation",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SU_TABLE_DEFINITION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("table_definition",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SU_INDEX_DEFINITION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("index_definition",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SU_PRIVILEGE_DEFINITION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("privilege_definition",-1)) == TCL_ERROR) return TCL_ERROR;
			}
 			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-scroll_options",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_SCROLL_OPTIONS,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -scroll_options",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_SO_FORWARD_ONLY) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("forward_only",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SO_STATIC) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("static",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SO_KEYSET_DRIVEN) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("keyset_driven",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SO_DYNAMIC) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("dynamic",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SO_MIXED) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("mixed",-1)) == TCL_ERROR) return TCL_ERROR;
			}
 			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-search_pattern_escape",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_SEARCH_PATTERN_ESCAPE,
				   (SQLPOINTER)tempstring,sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -search_pattern_escape",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewStringObj(tempstring,-1));
			return TCL_OK;
		} else if (strncasecmp(what,"-server_name",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_SERVER_NAME,
				   (SQLPOINTER)tempstring,sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -server_name",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewStringObj(tempstring,-1));
			return TCL_OK;
		} else if (strncasecmp(what,"-special_characters",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_SPECIAL_CHARACTERS,
				   (SQLPOINTER)tempstring,sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -special_characters",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewStringObj(tempstring,-1));
			return TCL_OK;
		} else if (strncasecmp(what,"-sql_conformance",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_SQL_CONFORMANCE,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -sql_conformance",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_SC_SQL92_ENTRY) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sql92_entry",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SC_FIPS127_2_TRANSITIONAL) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("fips127_2_transitional",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SC_SQL92_FULL) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sql92_full",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SC_SQL92_INTERMEDIATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj(" sql92_intermediate",-1)) == TCL_ERROR) return TCL_ERROR;
			}
 			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-sql92_datetime_functions",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_SQL92_DATETIME_FUNCTIONS,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -sql92_datetime_functions",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_SDF_CURRENT_DATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("current_date",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SDF_CURRENT_TIME) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("current_time",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SDF_CURRENT_TIMESTAMP) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("current_timestamp",-1)) == TCL_ERROR) return TCL_ERROR;
			}
 			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-sql92_foreign_key_delete_rule",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_SQL92_FOREIGN_KEY_DELETE_RULE,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -sql92_foreign_key_delete_rule",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_SFKD_CASCADE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("cascade",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SFKD_NO_ACTION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("no_action",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SFKD_SET_DEFAULT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("set_default",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SFKD_SET_NULL) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("set_null",-1)) == TCL_ERROR) return TCL_ERROR;
			}
 			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-sql92_foreign_key_update_rule",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_SQL92_FOREIGN_KEY_UPDATE_RULE,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -sql92_foreign_key_update_rule",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_SFKU_CASCADE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("cascade",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SFKU_NO_ACTION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("no_action",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SFKU_SET_DEFAULT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("set_default",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SFKU_SET_NULL) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("set_null",-1)) == TCL_ERROR) return TCL_ERROR;
			}
 			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-sql92_grant",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_SQL92_GRANT,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -sql92_grant",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_SG_DELETE_TABLE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("delete_table",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SG_INSERT_COLUMN) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("insert_column",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SG_INSERT_TABLE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("insert_table",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SG_REFERENCES_TABLE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("references_table",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SG_REFERENCES_COLUMN) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("references_column",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SG_SELECT_TABLE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("select_table",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SG_UPDATE_COLUMN) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("update_column",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SG_UPDATE_TABLE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("update_table",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SG_USAGE_ON_DOMAIN) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("usage_on_domain",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SG_USAGE_ON_CHARACTER_SET) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("usage_on_character_set",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SG_USAGE_ON_COLLATION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("usage_on_collation",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SG_USAGE_ON_TRANSLATION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("usage_on_translation",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SG_WITH_GRANT_OPTION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("with_grant_option",-1)) == TCL_ERROR) return TCL_ERROR;
			}
 			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-sql92_numeric_value_functions",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_SQL92_NUMERIC_VALUE_FUNCTIONS,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -sql92_numeric_value_functions",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_SNVF_BIT_LENGTH) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("bit_length",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SNVF_CHAR_LENGTH) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("char_length",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SNVF_CHARACTER_LENGTH) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("character_length",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SNVF_EXTRACT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("extract",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SNVF_OCTET_LENGTH) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("octet_length",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SNVF_POSITION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("position",-1)) == TCL_ERROR) return TCL_ERROR;
			}
 			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-sql92_predicates",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_SQL92_PREDICATES,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -sql92_predicates",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_SP_BETWEEN) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("between",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SP_COMPARISON) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("comparison",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SP_EXISTS) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("exists",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SP_IN) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("in",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SP_ISNOTNULL) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("isnotnull",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SP_ISNULL) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("isnull",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SP_LIKE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("like",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SP_MATCH_FULL) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("match_full",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SP_MATCH_PARTIAL) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("match_partial",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SP_MATCH_UNIQUE_FULL) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("match_unique_full",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SP_MATCH_UNIQUE_PARTIAL) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("match_unique_partial",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SP_OVERLAPS) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("overlaps",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SP_QUANTIFIED_COMPARISON) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("quantified_comparison",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SP_UNIQUE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("unique",-1)) == TCL_ERROR) return TCL_ERROR;
			}
 			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-sql92_relational_join_operators",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_SQL92_RELATIONAL_JOIN_OPERATORS,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -sql92_relational_join_operators",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_SRJO_CORRESPONDING_CLAUSE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("corresponding_clause",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SRJO_CROSS_JOIN) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("cross_join",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SRJO_EXCEPT_JOIN) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("except_join",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SRJO_FULL_OUTER_JOIN) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("full_outer_join",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SRJO_INNER_JOIN) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("inner_join",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SRJO_INTERSECT_JOIN) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("intersect_join",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SRJO_LEFT_OUTER_JOIN) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("left_outer_join",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SRJO_NATURAL_JOIN) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("natural_join",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SRJO_RIGHT_OUTER_JOIN) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("right_outer_join",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SRJO_UNION_JOIN) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("union_join",-1)) == TCL_ERROR) return TCL_ERROR;
			}
 			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-sql92_revoke",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_SQL92_REVOKE,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -sql92_revoke",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_SR_CASCADE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("cascade",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SR_DELETE_TABLE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("delete_table",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SR_GRANT_OPTION_FOR) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("grant_option_for",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SR_INSERT_COLUMN) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("insert_column",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SR_INSERT_TABLE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("insert_table",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SR_REFERENCES_COLUMN) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("references_column",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SR_REFERENCES_TABLE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("references_table",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SR_RESTRICT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("restrict",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SR_SELECT_TABLE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("select_table",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SR_UPDATE_COLUMN) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("update_column",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SR_UPDATE_TABLE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("update_table",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SR_USAGE_ON_DOMAIN) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("usage_on_domain",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SR_USAGE_ON_CHARACTER_SET) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("usage_on_character_set",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SR_USAGE_ON_COLLATION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("usage_on_collation",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SR_USAGE_ON_TRANSLATION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("usage_on_translation",-1)) == TCL_ERROR) return TCL_ERROR;
			}
 			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-sql92_row_value_constructor",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_SQL92_ROW_VALUE_CONSTRUCTOR,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -sql92_row_value_constructor",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_SRVC_VALUE_EXPRESSION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("value_expression",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SRVC_NULL) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("null",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SRVC_DEFAULT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("default",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SRVC_ROW_SUBQUERY) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("row_subquery",-1)) == TCL_ERROR) return TCL_ERROR;
			}
 			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-sql92_string_functions",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_SQL92_STRING_FUNCTIONS,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -sql92_string_functions",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_SSF_CONVERT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("convert",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SSF_LOWER) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("lower",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SSF_UPPER) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("upper",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SSF_SUBSTRING) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("substring",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SSF_TRANSLATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("translate",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SSF_TRIM_BOTH) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("trim_both",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SSF_TRIM_LEADING) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("trim_leading",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SSF_TRIM_TRAILING) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("trim_trailing",-1)) == TCL_ERROR) return TCL_ERROR;
			}
 			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-sql92_value_expressions",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_SQL92_VALUE_EXPRESSIONS,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -sql92_value_expressions",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_SVE_CASE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("case",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SVE_CAST) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("cast",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SVE_COALESCE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("coalesce",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SVE_NULLIF) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("nullif",-1)) == TCL_ERROR) return TCL_ERROR;
			}
 			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-standard_cli_conformance",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_STANDARD_CLI_CONFORMANCE,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -standard_cli_conformance",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_SCC_XOPEN_CLI_VERSION1) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("xopen_cli_version1",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SCC_ISO92_CLI) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("iso92_cli",-1)) == TCL_ERROR) return TCL_ERROR;
			}
 			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-static_cursor_attributes",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_STATIC_CURSOR_ATTRIBUTES1,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -static_cursor_attributes",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_CA1_NEXT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("next",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_ABSOLUTE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("absolute",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_RELATIVE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("relative",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_BOOKMARK) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("bookmark",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_LOCK_EXCLUSIVE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("lock_exclusive",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_LOCK_NO_CHANGE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("lock_no_change",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_LOCK_UNLOCK) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("lock_unlock",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_POS_POSITION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("pos_position",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_POS_UPDATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("pos_update",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_POS_DELETE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("pos_delete",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_POS_REFRESH) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("pos_refresh",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_POSITIONED_UPDATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("positioned_update",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_POSITIONED_DELETE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("positioned_delete",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_SELECT_FOR_UPDATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("select_for_update",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_BULK_ADD) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("bulk_add",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_BULK_UPDATE_BY_BOOKMARK) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("bulk_update_by_bookmark",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_BULK_DELETE_BY_BOOKMARK) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("bulk_delete_by_bookmark",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA1_BULK_FETCH_BY_BOOKMARK) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("bulk_fetch_by_bookmark",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			ret = SQLGetInfo(self->dbc,SQL_STATIC_CURSOR_ATTRIBUTES2,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -static_cursor_attributes",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_READ_ONLY_CONCURRENCY) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("read_only_concurrency",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_LOCK_CONCURRENCY) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("lock_concurrency",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_OPT_ROWVER_CONCURRENCY) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("opt_rowver_concurrency",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_OPT_VALUES_CONCURRENCY) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("opt_values_concurrency",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_SENSITIVITY_ADDITIONS) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sensitivity_additions",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_SENSITIVITY_DELETIONS) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sensitivity_deletions",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_SENSITIVITY_UPDATES) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("sensitivity_updates",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_MAX_ROWS_SELECT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("max_rows_select",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_MAX_ROWS_INSERT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("max_rows_insert",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_MAX_ROWS_DELETE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("max_rows_delete",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_MAX_ROWS_UPDATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("max_rows_update",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_MAX_ROWS_CATALOG) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("max_rows_catalog",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_MAX_ROWS_AFFECTS_ALL) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("max_rows_affects_all",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_CRC_EXACT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("crc_exact",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_CRC_APPROXIMATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("crc_approximate",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_SIMULATE_NON_UNIQUE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("simulate_non_unique",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_SIMULATE_TRY_UNIQUE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("simulate_try_unique",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_CA2_SIMULATE_UNIQUE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("simulate_unique",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-string_functions",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_STRING_FUNCTIONS,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -string_functions",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_FN_STR_ASCII) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("ascii",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_STR_BIT_LENGTH) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("bit_length",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_STR_CHAR) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("char",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_STR_CHAR_LENGTH) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("char_length",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_STR_CHARACTER_LENGTH) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("character_length",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_STR_CONCAT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("concat",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_STR_DIFFERENCE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("difference",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_STR_INSERT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("insert",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_STR_LCASE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("lcase",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_STR_LEFT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("left",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_STR_LENGTH) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("length",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_STR_LOCATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("locate",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_STR_LTRIM) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("ltrim",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_STR_OCTET_LENGTH) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("octet_length",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_STR_POSITION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("position",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_STR_REPEAT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("repeat",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_STR_REPLACE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("replace",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_STR_RIGHT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("right",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_STR_RTRIM) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("rtrim",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_STR_SOUNDEX) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("soundex",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_STR_SPACE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("space",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_STR_SUBSTRING) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("substring",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_STR_UCASE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("ucase",-1)) == TCL_ERROR) return TCL_ERROR;
			}
 			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-subqueries",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_SUBQUERIES,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -subqueries",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_SQ_CORRELATED_SUBQUERIES) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("correlated_subqueries",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SQ_COMPARISON) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("comparison",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SQ_EXISTS) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("exists",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SQ_IN) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("in",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_SQ_QUANTIFIED) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("quantified",-1)) == TCL_ERROR) return TCL_ERROR;
			}
 			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-system_functions",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_SYSTEM_FUNCTIONS,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -system_functions",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_FN_SYS_DBNAME) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("dbname",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_SYS_IFNULL) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("ifnull",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_SYS_USERNAME) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("username",-1)) == TCL_ERROR) return TCL_ERROR;
			}
 			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-table_term",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_TABLE_TERM,
				   (SQLPOINTER)tempstring,sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -table_term",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewStringObj(tempstring,-1));
			return TCL_OK;
		} else if (strncasecmp(what,"-timedate_add_intervals",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_TIMEDATE_ADD_INTERVALS,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -timedate_add_intervals",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_FN_TSI_FRAC_SECOND) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("tsi_frac_second",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TSI_SECOND) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("tsi_second",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TSI_MINUTE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("tsi_minute",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TSI_HOUR) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("tsi_hour",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TSI_DAY) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("tsi_day",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TSI_WEEK) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("tsi_week",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TSI_MONTH) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("tsi_month",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TSI_QUARTER) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("tsi_quarter",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TSI_YEAR) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("tsi_year",-1)) == TCL_ERROR) return TCL_ERROR;
			}
 			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-timedate_diff_intervals",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_TIMEDATE_DIFF_INTERVALS,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -timedate_diff_intervals",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_FN_TSI_FRAC_SECOND) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("tsi_frac_second",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TSI_SECOND) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("tsi_second",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TSI_MINUTE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("tsi_minute",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TSI_HOUR) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("tsi_hour",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TSI_DAY) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("tsi_day",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TSI_WEEK) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("tsi_week",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TSI_MONTH) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("tsi_month",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TSI_QUARTER) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("tsi_quarter",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TSI_YEAR) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("tsi_year",-1)) == TCL_ERROR) return TCL_ERROR;
			}
 			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-timedate_functions",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_TIMEDATE_FUNCTIONS,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -timedate_functions",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_FN_TD_CURRENT_DATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("current_date",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TD_CURRENT_TIME) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("current_time",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TD_CURRENT_TIMESTAMP) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("current_timestamp",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TD_CURDATE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("curdate",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TD_CURTIME) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("curtime",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TD_DAYNAME) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("dayname",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TD_DAYOFMONTH) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("dayofmonth",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TD_DAYOFWEEK) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("dayofweek",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TD_DAYOFYEAR) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("dayofyear",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TD_EXTRACT) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("extract",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TD_HOUR) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("hour",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TD_MINUTE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("minute",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TD_MONTH) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("month",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TD_MONTHNAME) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("monthname",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TD_NOW) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("now",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TD_QUARTER) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("quarter",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TD_SECOND) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("second",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TD_TIMESTAMPADD) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("timestampadd",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TD_TIMESTAMPDIFF) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("timestampdiff",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TD_WEEK) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("week",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_FN_TD_YEAR) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("year",-1)) == TCL_ERROR) return TCL_ERROR;
			}
 			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-txn_capable",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_TXN_CAPABLE,
				   (SQLPOINTER)&tempsmallint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -txn_capable",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			switch (tempsmallint) {
			   case SQL_TC_NONE:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("none",-1));
				return TCL_OK;
			   case SQL_TC_DML:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("dml",-1));
				return TCL_OK;
			   case SQL_TC_DDL_COMMIT:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("ddl_commit",-1));
				return TCL_OK;
			   case SQL_TC_DDL_IGNORE:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("ddl_ignore",-1));
				return TCL_OK;
			   case SQL_TC_ALL:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("all",-1));
				return TCL_OK;
			   default:
			   	Tcl_SetObjResult(interp,Tcl_NewStringObj("unknown result",-1));
			   	return TCL_ERROR;
			}
		} else if (strncasecmp(what,"-txn_isolation_option",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_TXN_ISOLATION_OPTION,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -txn_isolation_option",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_TXN_READ_UNCOMMITTED) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("read_uncommitted",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_TXN_READ_COMMITTED) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("read_committed",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_TXN_REPEATABLE_READ) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("repeatable_read",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_TXN_SERIALIZABLE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("serializable",-1)) == TCL_ERROR) return TCL_ERROR;
			}
 			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-union",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_UNION,
				   (SQLPOINTER)&tempint,0,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -union",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_U_UNION) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("union",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_U_UNION_ALL) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("union_all",-1)) == TCL_ERROR) return TCL_ERROR;
			}
 			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		} else if (strncasecmp(what,"-user_name",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_USER_NAME,
				   (SQLPOINTER)tempstring,sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -user_name",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewStringObj(tempstring,-1));
			return TCL_OK;
		} else if (strncasecmp(what,"-xopen_cli_year",strlen(what)) == 0) {
			ret = SQLGetInfo(self->dbc,SQL_XOPEN_CLI_YEAR,
				   (SQLPOINTER)tempstring,sizeof(tempstring),NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -xopen_cli_year",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,Tcl_NewStringObj(tempstring,-1));
			return TCL_OK;
		/* Now SQLGetConnectAttr() ... */
		} else if (strncasecmp(what,"-attr_access_mode",strlen(what)) == 0) {
			ret = SQLGetConnectAttr(self->dbc,SQL_ATTR_ACCESS_MODE,
					(SQLPOINTER)&tempint,SQL_IS_UINTEGER,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -attr_access_mode",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			switch (tempint) {
			    case SQL_MODE_READ_ONLY:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("read",-1));
				return TCL_OK;
			    case SQL_MODE_READ_WRITE:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("write",-1));
				return TCL_OK;
			    default:
			   	Tcl_SetObjResult(interp,Tcl_NewStringObj("unknown result",-1));
			   	return TCL_ERROR;
			}  
		} else if (strncasecmp(what,"-attr_async_enable",strlen(what)) == 0) {
			ret = SQLGetConnectAttr(self->dbc,SQL_ATTR_ASYNC_ENABLE,
					(SQLPOINTER)&tempint,SQL_IS_UINTEGER,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -attr_async_enable",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			switch (tempint) {
			    case SQL_ASYNC_ENABLE_OFF:
				Tcl_SetObjResult(interp,Tcl_NewBooleanObj(0));
				return TCL_OK;
			    case SQL_ASYNC_ENABLE_ON:
				Tcl_SetObjResult(interp,Tcl_NewBooleanObj(1));
				return TCL_OK;
			    default:
			   	Tcl_SetObjResult(interp,Tcl_NewStringObj("unknown result",-1));
			   	return TCL_ERROR;
			}
		} else if (strncasecmp(what,"-attr_auto_ipd",strlen(what)) == 0) {
			ret = SQLGetConnectAttr(self->dbc,SQL_ATTR_AUTO_IPD,
					(SQLPOINTER)&tempint,SQL_IS_UINTEGER,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -attr_auto_ipd",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			switch (tempint) {
			    case SQL_FALSE:
				Tcl_SetObjResult(interp,Tcl_NewBooleanObj(0));
				return TCL_OK;
			    case SQL_TRUE:
				Tcl_SetObjResult(interp,Tcl_NewBooleanObj(1));
				return TCL_OK;
			    default:
			   	Tcl_SetObjResult(interp,Tcl_NewStringObj("unknown result",-1));
			   	return TCL_ERROR;
			}
		} else if (strncasecmp(what,"-attr_autocommit",strlen(what)) == 0) {
			ret = SQLGetConnectAttr(self->dbc,SQL_ATTR_AUTOCOMMIT,
					(SQLPOINTER)&tempint,SQL_IS_UINTEGER,NULL);  
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -attr_autocommit",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			switch (tempint) {
			    case SQL_AUTOCOMMIT_OFF:
				Tcl_SetObjResult(interp,Tcl_NewBooleanObj(0));
				return TCL_OK;
			    case SQL_AUTOCOMMIT_ON:
				Tcl_SetObjResult(interp,Tcl_NewBooleanObj(1));
				return TCL_OK;
			    default:
			   	Tcl_SetObjResult(interp,Tcl_NewStringObj("unknown result",-1));
			   	return TCL_ERROR;
			}
		} else if (strncasecmp(what,"-attr_connection_dead",strlen(what)) == 0) {
			ret = SQLGetConnectAttr(self->dbc,SQL_ATTR_CONNECTION_DEAD,
					(SQLPOINTER)&tempint,SQL_IS_UINTEGER,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -attr_connection_dead",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			switch (tempint) {
			    case SQL_CD_FALSE:
				Tcl_SetObjResult(interp,Tcl_NewBooleanObj(0));
				return TCL_OK;
			    case SQL_CD_TRUE:
				Tcl_SetObjResult(interp,Tcl_NewBooleanObj(1));
				return TCL_OK;
			    default:
			   	Tcl_SetObjResult(interp,Tcl_NewStringObj("unknown result",-1));
			   	return TCL_ERROR;
			}
		} else if (strncasecmp(what,"-attr_connection_timeout",strlen(what)) == 0) {
			ret = SQLGetConnectAttr(self->dbc,SQL_ATTR_CONNECTION_TIMEOUT,
					(SQLPOINTER)&tempint,SQL_IS_UINTEGER,NULL);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -attr_connection_timeout",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
 			Tcl_SetObjResult(interp,Tcl_NewLongObj(tempint));
			return TCL_OK;
		} else if (strncasecmp(what,"-attr_current_catalog",strlen(what)) == 0) {
			ret = SQLGetConnectAttr(self->dbc,SQL_ATTR_CURRENT_CATALOG,
					(SQLPOINTER)tempstring,sizeof(tempstring),NULL);  
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -attr_current_catalog",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj  *result = Tcl_NewStringObj(tempstring,-1);
			Tcl_SetObjResult(interp,result);
			return TCL_OK;
		} else if (strncasecmp(what,"-attr_login_timeout",strlen(what)) == 0) {
			ret = SQLGetConnectAttr(self->dbc,SQL_ATTR_LOGIN_TIMEOUT,
					(SQLPOINTER)&tempint,SQL_IS_UINTEGER,NULL);  
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -attr_login_timeout",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
 			Tcl_SetObjResult(interp,Tcl_NewLongObj(tempint));
			return TCL_OK;
		} else if (strncasecmp(what,"-attr_metadata_id",strlen(what)) == 0) {
			ret = SQLGetConnectAttr(self->dbc,SQL_ATTR_METADATA_ID,
					(SQLPOINTER)&tempint,SQL_IS_UINTEGER,NULL);  
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -attr_metadata_id",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			switch (tempint) {
			    case SQL_FALSE:
				Tcl_SetObjResult(interp,Tcl_NewBooleanObj(0));
				return TCL_OK;
			    case SQL_TRUE:
				Tcl_SetObjResult(interp,Tcl_NewBooleanObj(1));
				return TCL_OK;
			    default:
			   	Tcl_SetObjResult(interp,Tcl_NewStringObj("unknown result",-1));
			   	return TCL_ERROR;
			}
		} else if (strncasecmp(what,"-attr_odbc_cursors",strlen(what)) == 0) {
			ret = SQLGetConnectAttr(self->dbc,SQL_ATTR_ODBC_CURSORS,
					(SQLPOINTER)&tempint,SQL_IS_UINTEGER,NULL);  
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -attr_odbc_cursors",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			switch (tempint) {
			    case SQL_CUR_USE_IF_NEEDED:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("if_needed",-1));
				return TCL_OK;
			    case SQL_CUR_USE_ODBC:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("odbc",-1));
				return TCL_OK;
			    case SQL_CUR_USE_DRIVER:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("driver",-1));
				return TCL_OK;
			    default:
				Tcl_SetObjResult(interp,Tcl_NewStringObj("unknown result",-1));
				return TCL_ERROR;
			}
		} else if (strncasecmp(what,"-attr_packet_size",strlen(what)) == 0) {
			ret = SQLGetConnectAttr(self->dbc,SQL_ATTR_PACKET_SIZE,
					(SQLPOINTER)&tempint,SQL_IS_UINTEGER,NULL);  
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -attr_packet_size",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
 			Tcl_SetObjResult(interp,Tcl_NewLongObj(tempint));
			return TCL_OK;
		} else if (strncasecmp(what,"-attr_trace",strlen(what)) == 0) {
			ret = SQLGetConnectAttr(self->dbc,SQL_ATTR_TRACE,
					(SQLPOINTER)&tempint,SQL_IS_UINTEGER,NULL);  
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -attr_trace",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			switch (tempint) {
			    case SQL_OPT_TRACE_OFF:
				Tcl_SetObjResult(interp,Tcl_NewBooleanObj(0));
				return TCL_OK;
			    case SQL_OPT_TRACE_ON:
				Tcl_SetObjResult(interp,Tcl_NewBooleanObj(1));
				return TCL_OK;
			    default:
			   	Tcl_SetObjResult(interp,Tcl_NewStringObj("unknown result",-1));
			   	return TCL_ERROR;
			}
		} else if (strncasecmp(what,"-attr_tracefile",strlen(what)) == 0) {
			ret = SQLGetConnectAttr(self->dbc,SQL_ATTR_TRACEFILE,
					(SQLPOINTER)tempstring,sizeof(tempstring),NULL);  
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -attr_tracefile",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj  *result = Tcl_NewStringObj(tempstring,-1);
			Tcl_SetObjResult(interp,result);
			return TCL_OK;
		} else if (strncasecmp(what,"-attr_translate_lib",strlen(what)) == 0) {
			ret = SQLGetConnectAttr(self->dbc,SQL_ATTR_TRANSLATE_LIB,
					(SQLPOINTER)tempstring,sizeof(tempstring),NULL);  
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -attr_translate_lib",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj  *result = Tcl_NewStringObj(tempstring,-1);
			Tcl_SetObjResult(interp,result);
			return TCL_OK;
		} else if (strncasecmp(what,"-attr_translate_option",strlen(what)) == 0) {
			ret = SQLGetConnectAttr(self->dbc,SQL_ATTR_TRANSLATE_OPTION,
					(SQLPOINTER)&tempint,SQL_IS_UINTEGER,NULL);  
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -attr_translate_option",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
 			Tcl_SetObjResult(interp,Tcl_NewLongObj(tempint));
			return TCL_OK;
		} else if (strncasecmp(what,"-attr_txn_isolation",strlen(what)) == 0) {
			ret = SQLGetConnectAttr(self->dbc,SQL_ATTR_TXN_ISOLATION,
					(SQLPOINTER)&tempint,SQL_IS_UINTEGER,NULL);  
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("cget -attr_txn_isolation",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			Tcl_Obj *bits = Tcl_NewObj();
			if ((tempint & SQL_TXN_READ_UNCOMMITTED) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("read_uncommitted",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_TXN_READ_COMMITTED) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("read_committed",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_TXN_REPEATABLE_READ) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("repeatable_read",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			if ((tempint & SQL_TXN_SERIALIZABLE) != 0) {
			    if (Tcl_ListObjAppendElement(interp,bits,Tcl_NewStringObj("serializable",-1)) == TCL_ERROR) return TCL_ERROR;
			}
			Tcl_SetObjResult(interp,bits);
			return TCL_OK;
		/* Copied from SWIG Generated code */
#if SWIGVERSIONMINOR == 1 && SWIGVERSIONMAJOR == 1
			SWIG_MakePtr(interp->result,(void *) self, "_connection_p");
			return TCL_OK;
#else
		} else if (strcmp(what,"-this") == 0) {
			Tcl_SetObjResult(interp, SWIG_NewInstanceObj((void *) self,SWIGTYPE_p_connection,0));
			return TCL_OK;
		} else if (strcmp(what,"-thisown") == 0) {
			if (SWIG_Thisown(self)) 
				Tcl_SetObjResult(interp, Tcl_NewBooleanObj(1));
			else	Tcl_SetObjResult(interp, Tcl_NewBooleanObj(0));
			return TCL_OK;
#endif
		} else {
			Tcl_Obj  *result = Tcl_NewStringObj("Unknown option: \"",-1);
			Tcl_AppendToObj(result,what,-1);
			Tcl_AppendToObj(result,"\", should be one of: ",-1);
			Tcl_AppendToObj(result,"-accessible_tables ",-1);
			Tcl_AppendToObj(result,"-accessible_procedures ",-1);
			Tcl_AppendToObj(result,"-active_environments ",-1);
			Tcl_AppendToObj(result,"-aggregate_functions ",-1);
			Tcl_AppendToObj(result,"-alter_domain ",-1);
			Tcl_AppendToObj(result,"-alter_table ",-1);
			Tcl_AppendToObj(result,"-async_mode ",-1);
			Tcl_AppendToObj(result,"-batch_row_count ",-1);
			Tcl_AppendToObj(result,"-batch_support ",-1);
			Tcl_AppendToObj(result,"-bookmark_persistence ",-1);
			Tcl_AppendToObj(result,"-catalog_location ",-1);
			Tcl_AppendToObj(result,"-catalog_name ",-1);
			Tcl_AppendToObj(result,"-catalog_name_separator ",-1);
			Tcl_AppendToObj(result,"-catalog_term ",-1);
			Tcl_AppendToObj(result,"-catalog_usage ",-1);
			Tcl_AppendToObj(result,"-collation_seq ",-1);
			Tcl_AppendToObj(result,"-column_alias ",-1);
			Tcl_AppendToObj(result,"-concat_null_behavior ",-1);
			Tcl_AppendToObj(result,"-convert_functions ",-1);
			Tcl_AppendToObj(result,"-convert_bigint ",-1);
			Tcl_AppendToObj(result,"-convert_binary ",-1);
			Tcl_AppendToObj(result,"-convert_bit ",-1);
			Tcl_AppendToObj(result,"-convert_char ",-1);
			Tcl_AppendToObj(result,"-convert_guid ",-1);
			Tcl_AppendToObj(result,"-convert_date ",-1);
			Tcl_AppendToObj(result,"-convert_decimal ",-1);
			Tcl_AppendToObj(result,"-convert_double ",-1);
			Tcl_AppendToObj(result,"-convert_float ",-1);
			Tcl_AppendToObj(result,"-convert_integer ",-1);
			Tcl_AppendToObj(result,"-convert_interval_year_month ",-1);
			Tcl_AppendToObj(result,"-convert_interval_day_time ",-1);
			Tcl_AppendToObj(result,"-convert_longvarbinary ",-1);
			Tcl_AppendToObj(result,"-convert_longvarchar ",-1);
			Tcl_AppendToObj(result,"-convert_numeric ",-1);
			Tcl_AppendToObj(result,"-convert_real ",-1);
			Tcl_AppendToObj(result,"-convert_smallint ",-1);
			Tcl_AppendToObj(result,"-convert_time ",-1);
			Tcl_AppendToObj(result,"-convert_timestamp ",-1);
			Tcl_AppendToObj(result,"-convert_tinyint ",-1);
			Tcl_AppendToObj(result,"-convert_varbinary ",-1);
			Tcl_AppendToObj(result,"-convert_varchar ",-1);
			Tcl_AppendToObj(result,"-correlation_name ",-1);
			Tcl_AppendToObj(result,"-create_assertion ",-1);
			Tcl_AppendToObj(result,"-create_character_set ",-1);
			Tcl_AppendToObj(result,"-create_collation ",-1);
			Tcl_AppendToObj(result,"-create_domain ",-1);
			Tcl_AppendToObj(result,"-create_schema ",-1);
			Tcl_AppendToObj(result,"-create_table ",-1);
			Tcl_AppendToObj(result,"-create_translation ",-1);
			Tcl_AppendToObj(result,"-create_view ",-1);
			Tcl_AppendToObj(result,"-cursor_commit_behavior ",-1);
			Tcl_AppendToObj(result,"-cursor_rollback_behavior ",-1);
			Tcl_AppendToObj(result,"-cursor_rollback_sql_cursor_sensitivity ",-1);
			Tcl_AppendToObj(result,"-data_source_name ",-1);
			Tcl_AppendToObj(result,"-data_source_read_only ",-1);
			Tcl_AppendToObj(result,"-database_name ",-1);
			Tcl_AppendToObj(result,"-datetime_literals ",-1);
			Tcl_AppendToObj(result,"-dbms_name ",-1);
			Tcl_AppendToObj(result,"-dbms_ver ",-1);
			Tcl_AppendToObj(result,"-ddl_index ",-1);
			Tcl_AppendToObj(result,"-default_txn_isolation ",-1);
			Tcl_AppendToObj(result,"-describe_parameter ",-1);
			Tcl_AppendToObj(result,"-dm_ver ",-1);
			Tcl_AppendToObj(result,"-driver_name ",-1);
			Tcl_AppendToObj(result,"-driver_odbc_ver ",-1);
			Tcl_AppendToObj(result,"-driver_ver ",-1);
			Tcl_AppendToObj(result,"-drop_assertion ",-1);
			Tcl_AppendToObj(result,"-drop_character_set ",-1);
			Tcl_AppendToObj(result,"-drop_collation ",-1);
			Tcl_AppendToObj(result,"-drop_domain ",-1);
			Tcl_AppendToObj(result,"-drop_schema ",-1);
			Tcl_AppendToObj(result,"-drop_table ",-1);
			Tcl_AppendToObj(result,"-drop_translation ",-1);
			Tcl_AppendToObj(result,"-drop_view ",-1);
			Tcl_AppendToObj(result,"-dynamic_cursor_attributes ",-1);
			Tcl_AppendToObj(result,"-expressions_in_orderby ",-1);
			Tcl_AppendToObj(result,"-file_usage ",-1);
			Tcl_AppendToObj(result,"-forward_only_cursor_attributes ",-1);
			Tcl_AppendToObj(result,"-getdata_extensions ",-1);
			Tcl_AppendToObj(result,"-group_by ",-1);
			Tcl_AppendToObj(result,"-identifier_case ",-1);
			Tcl_AppendToObj(result,"-identifier_quote_char ",-1);
			Tcl_AppendToObj(result,"-index_keywords ",-1);
			Tcl_AppendToObj(result,"-info_schema_views ",-1);
			Tcl_AppendToObj(result,"-insert_statement ",-1);
			Tcl_AppendToObj(result,"-integrity ",-1);
			Tcl_AppendToObj(result,"-keyset_cursor_attributes ",-1);
			Tcl_AppendToObj(result,"-keywords ",-1);
			Tcl_AppendToObj(result,"-like_escape_clause ",-1);
			Tcl_AppendToObj(result,"-max_async_concurrent_statements ",-1);
			Tcl_AppendToObj(result,"-max_binary_literal_len ",-1);
			Tcl_AppendToObj(result,"-max_catalog_name_len ",-1);
			Tcl_AppendToObj(result,"-max_char_literal_len ",-1);
			Tcl_AppendToObj(result,"-max_column_name_len ",-1);
			Tcl_AppendToObj(result,"-max_columns_in_group_by ",-1);
			Tcl_AppendToObj(result,"-max_columns_in_index ",-1);
			Tcl_AppendToObj(result,"-max_columns_in_order_by ",-1);
			Tcl_AppendToObj(result,"-max_columns_in_select ",-1);
			Tcl_AppendToObj(result,"-max_columns_in_table ",-1);
			Tcl_AppendToObj(result,"-max_concurrent_activities ",-1);
			Tcl_AppendToObj(result,"-max_cursor_name_len ",-1);
			Tcl_AppendToObj(result,"-max_driver_connections ",-1);
			Tcl_AppendToObj(result,"-max_identifier_len ",-1);
			Tcl_AppendToObj(result,"-max_index_size ",-1);
			Tcl_AppendToObj(result,"-max_procedure_name_len ",-1);
			Tcl_AppendToObj(result,"-max_row_size_includes_long ",-1);
			Tcl_AppendToObj(result,"-max_row_size ",-1);
			Tcl_AppendToObj(result,"-max_schema_name_len ",-1);
			Tcl_AppendToObj(result,"-max_statement_len ",-1);
			Tcl_AppendToObj(result,"-max_table_name_len ",-1);
			Tcl_AppendToObj(result,"-max_tables_in_select ",-1);
			Tcl_AppendToObj(result,"-max_user_name_len ",-1);
			Tcl_AppendToObj(result,"-mult_result_sets ",-1);
			Tcl_AppendToObj(result,"-multiple_active_txn ",-1);
			Tcl_AppendToObj(result,"-need_long_data_len ",-1);
			Tcl_AppendToObj(result,"-non_nullable_columns ",-1);
			Tcl_AppendToObj(result,"-null_collation ",-1);
			Tcl_AppendToObj(result,"-numeric_functions ",-1);
			Tcl_AppendToObj(result,"-odbc_interface_conformance ",-1);
			Tcl_AppendToObj(result,"-odbc_ver ",-1);
			Tcl_AppendToObj(result,"-oj_capabilities ",-1);
			Tcl_AppendToObj(result,"-order_by_columns_in_select ",-1);
			Tcl_AppendToObj(result,"-param_array_row_counts ",-1);
			Tcl_AppendToObj(result,"-param_array_selects ",-1);
			Tcl_AppendToObj(result,"-procedure_term ",-1);
			Tcl_AppendToObj(result,"-procedures ",-1);
			Tcl_AppendToObj(result,"-pos_operations ",-1);
			Tcl_AppendToObj(result,"-quoted_identifier_case ",-1);
			Tcl_AppendToObj(result,"-row_updates ",-1);
			Tcl_AppendToObj(result,"-schema_term ",-1);
			Tcl_AppendToObj(result,"-schema_usage ",-1);
			Tcl_AppendToObj(result,"-scroll_options ",-1);
			Tcl_AppendToObj(result,"-search_pattern_escape ",-1);
			Tcl_AppendToObj(result,"-server_name ",-1);
			Tcl_AppendToObj(result,"-special_characters ",-1);
			Tcl_AppendToObj(result,"-sql_conformance ",-1);
			Tcl_AppendToObj(result,"-sql92_datetime_functions ",-1);
			Tcl_AppendToObj(result,"-sql92_foreign_key_delete_rule ",-1);
			Tcl_AppendToObj(result,"-sql92_foreign_key_update_rule ",-1);
			Tcl_AppendToObj(result,"-sql92_grant ",-1);
			Tcl_AppendToObj(result,"-sql92_numeric_value_functions ",-1);
			Tcl_AppendToObj(result,"-sql92_predicates ",-1);
			Tcl_AppendToObj(result,"-sql92_relational_join_operators ",-1);
			Tcl_AppendToObj(result,"-sql92_revoke ",-1);
			Tcl_AppendToObj(result,"-sql92_row_value_constructor ",-1);
			Tcl_AppendToObj(result,"-sql92_string_functions ",-1);
			Tcl_AppendToObj(result,"-sql92_value_expressions ",-1);
			Tcl_AppendToObj(result,"-standard_cli_conformance ",-1);
			Tcl_AppendToObj(result,"-static_cursor_attributes ",-1);
			Tcl_AppendToObj(result,"-string_functions ",-1);
			Tcl_AppendToObj(result,"-subqueries ",-1);
			Tcl_AppendToObj(result,"-system_functions ",-1);
			Tcl_AppendToObj(result,"-table_term ",-1);
			Tcl_AppendToObj(result,"-timedate_add_intervals ",-1);
			Tcl_AppendToObj(result,"-timedate_diff_intervals ",-1);
			Tcl_AppendToObj(result,"-timedate_functions ",-1);
			Tcl_AppendToObj(result,"-txn_capable ",-1);
			Tcl_AppendToObj(result,"-txn_isolation_option ",-1);
			Tcl_AppendToObj(result,"-union ",-1);
			Tcl_AppendToObj(result,"-user_name ",-1);
			Tcl_AppendToObj(result,"-xopen_cli_year ",-1);
			Tcl_AppendToObj(result,"-attr_access_mode ",-1);
			Tcl_AppendToObj(result,"-attr_async_enable ",-1);
			Tcl_AppendToObj(result,"-attr_auto_ipd ",-1);
			Tcl_AppendToObj(result,"-attr_autocommit ",-1);
			Tcl_AppendToObj(result,"-attr_connection_dead ",-1);
			Tcl_AppendToObj(result,"-attr_connection_timeout ",-1);
			Tcl_AppendToObj(result,"-attr_current_catalog ",-1);
			Tcl_AppendToObj(result,"-attr_login_timeout ",-1);
			Tcl_AppendToObj(result,"-attr_metadata_id ",-1);
			Tcl_AppendToObj(result,"-attr_odbc_cursors ",-1);
			Tcl_AppendToObj(result,"-attr_packet_size ",-1);
			Tcl_AppendToObj(result,"-attr_trace ",-1);
			Tcl_AppendToObj(result,"-attr_tracefile ",-1);
			Tcl_AppendToObj(result,"-attr_translate_lib ",-1);
			Tcl_AppendToObj(result,"-attr_translate_option ",-1);
			Tcl_AppendToObj(result,"-attr_txn_isolation ",-1);
			Tcl_AppendToObj(result,"-this ",-1);
#if SWIGVERSIONMINOR == 1 && SWIGVERSIONMAJOR == 1
#else
			Tcl_AppendToObj(result,"-thisown ",-1);
#endif
			Tcl_SetObjResult(interp,result);
			return TCL_ERROR;
		}
	}
	/* SQLSetConnectAttr() calls */
	Tcl_Result configure(Tcl_Interp *interp,const char *what,Tcl_Obj *value) {
		SQLRETURN ret;
		SQLUSMALLINT tempsmallint;
		SQLUINTEGER  tempint;
		if (strncasecmp(what,"-attr_async_enable",strlen(what)) == 0) {
			int flag;
			if (Tcl_GetBooleanFromObj(interp,value,&flag) == TCL_ERROR) return TCL_ERROR;
			if (flag) tempint = SQL_ASYNC_ENABLE_ON;
			else	  tempint = SQL_ASYNC_ENABLE_OFF;
			ret = SQLSetConnectAttr(self->dbc,SQL_ATTR_ASYNC_ENABLE,
						(SQLPOINTER)tempint,
						SQL_IS_UINTEGER);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("configure -attr_async_enable",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			return TCL_OK;
		} else if (strncasecmp(what,"-attr_auto_ipd",strlen(what)) == 0) {
			int flag;
			if (Tcl_GetBooleanFromObj(interp,value,&flag) == TCL_ERROR) return TCL_ERROR;
			if (flag) tempint = SQL_TRUE;
			else	  tempint = SQL_FALSE;
			ret = SQLSetConnectAttr(self->dbc,SQL_ATTR_AUTO_IPD,
						(SQLPOINTER)tempint,
						SQL_IS_UINTEGER);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("configure -attr_auto_ipd",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			return TCL_OK;
		} else if (strncasecmp(what,"-attr_autocommit",strlen(what)) == 0) {
			int flag;
			if (Tcl_GetBooleanFromObj(interp,value,&flag) == TCL_ERROR) return TCL_ERROR;
			if (flag) tempint = SQL_AUTOCOMMIT_ON;
			else	  tempint = SQL_AUTOCOMMIT_OFF;
			ret = SQLSetConnectAttr(self->dbc,SQL_ATTR_AUTOCOMMIT,
						(SQLPOINTER)tempint,
						SQL_IS_UINTEGER);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("configure -attr_autocommit",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			return TCL_OK;
		} else if (strncasecmp(what,"-attr_connection_timeout",strlen(what)) == 0) {
			if (Tcl_GetLongFromObj(interp,value,&tempint) == TCL_ERROR) return TCL_ERROR;
			ret = SQLSetConnectAttr(self->dbc,SQL_ATTR_CONNECTION_TIMEOUT,
						(SQLPOINTER)tempint,SQL_IS_UINTEGER);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("configure -attr_connection_timeout",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			return TCL_OK;
		} else if (strncasecmp(what,"-attr_metadata_id",strlen(what)) == 0) {
			int flag;
			if (Tcl_GetBooleanFromObj(interp,value,&flag) == TCL_ERROR) return TCL_ERROR;
			if (flag) tempint = SQL_TRUE;
			else	  tempint = SQL_FALSE;
			ret = SQLSetConnectAttr(self->dbc,SQL_ATTR_METADATA_ID,
						(SQLPOINTER)tempint,
						SQL_IS_UINTEGER);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("configure -attr_metadata_id",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			return TCL_OK;
		} else if (strncasecmp(what,"-attr_trace",strlen(what)) == 0) {
			int flag;
			if (Tcl_GetBooleanFromObj(interp,value,&flag) == TCL_ERROR) return TCL_ERROR;
			if (flag) tempint = SQL_OPT_TRACE_ON;
			else	  tempint = SQL_OPT_TRACE_OFF;
			ret = SQLSetConnectAttr(self->dbc,SQL_ATTR_TRACE,
						(SQLPOINTER)tempint,
						SQL_IS_UINTEGER);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("configure -attr_trace",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			return TCL_OK;
		} else if (strncasecmp(what,"-attr_tracefile",strlen(what)) == 0) {
			ret = SQLSetConnectAttr(self->dbc,SQL_ATTR_TRACEFILE,
						(SQLPOINTER)Tcl_GetString(value),SQL_NTS);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("configure -attr_tracefile",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			return TCL_OK;
		} else if (strncasecmp(what,"-attr_translate_lib",strlen(what)) == 0) {
			ret = SQLSetConnectAttr(self->dbc,SQL_ATTR_TRANSLATE_LIB,
						(SQLPOINTER)Tcl_GetString(value),SQL_NTS);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("configure -attr_translate_lib",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			return TCL_OK;
		} else if (strncasecmp(what,"-attr_translate_option",strlen(what)) == 0) {
			if (Tcl_GetLongFromObj(interp,value,&tempint) == TCL_ERROR) return TCL_ERROR;
			ret = SQLSetConnectAttr(self->dbc,SQL_ATTR_TRANSLATE_OPTION,
						(SQLPOINTER)tempint,SQL_IS_UINTEGER);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("configure -attr_translate_option",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			return TCL_OK;
		} else if (strncasecmp(what,"-attr_txn_isolation",strlen(what)) == 0) {
			int len, i;
			Tcl_Obj *f;
			const char *fs;
			if (Tcl_ListObjLength(interp,value,&len) != TCL_OK) return TCL_ERROR;
			tempint = 0L;
			for (i = 0; i < len; i++) {
				Tcl_ListObjIndex(interp,value,i,&f);
				fs = Tcl_GetString(f);
				if (strncasecmp(fs,"read_uncommitted",strlen(fs)) == 0)
					tempint |= SQL_TXN_READ_UNCOMMITTED;
				else if (strncasecmp(fs,"read_committed",strlen(fs)) == 0)
					tempint |= SQL_TXN_READ_COMMITTED;
				else if (strncasecmp(fs,"repeatable_read",strlen(fs)) == 0)
					tempint |= SQL_TXN_REPEATABLE_READ;
				else if (strncasecmp(fs,"serializable",strlen(fs)) == 0)
					tempint |= SQL_TXN_SERIALIZABLE;
				else {
					Tcl_Obj  *result = Tcl_NewStringObj("Unknown transaction isolation level: \"",-1);
					Tcl_AppendToObj(result,fs,-1);
					Tcl_AppendToObj(result,"\"",-1);
					Tcl_SetObjResult(interp,result);
					return TCL_ERROR;
				}
				
			}
			ret = SQLSetConnectAttr(self->dbc,SQL_ATTR_TXN_ISOLATION,
						(SQLPOINTER)tempint,SQL_IS_UINTEGER);
			if (!SQL_SUCCEEDED(ret)) {
				extract_error_tointerp("configure -attr_txn_isolation",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
			}
			return TCL_OK;
		} else {
			Tcl_Obj  *result = Tcl_NewStringObj("Unknown option: \"",-1);
			Tcl_AppendToObj(result,what,-1);
			Tcl_AppendToObj(result,"\", should be one of: ",-1);
			Tcl_AppendToObj(result,"-attr_async_enable ",-1);
			Tcl_AppendToObj(result,"-attr_auto_ipd ",-1);
			Tcl_AppendToObj(result,"-attr_autocommit ",-1);
			Tcl_AppendToObj(result,"-attr_connection_timeout ",-1);
			Tcl_AppendToObj(result,"-attr_metadata_id ",-1);
			Tcl_AppendToObj(result,"-attr_trace ",-1);
			Tcl_AppendToObj(result,"-attr_tracefile ",-1);
			Tcl_AppendToObj(result,"-attr_translate_lib ",-1);
			Tcl_AppendToObj(result,"-attr_translate_option ",-1);
			Tcl_AppendToObj(result,"-attr_txn_isolation ",-1);
			Tcl_SetObjResult(interp,result);
			return TCL_ERROR;
		}
	}
	Tcl_Result commit(Tcl_Interp *interp) {
		SQLRETURN ret;
		ret = SQLEndTran(SQL_HANDLE_DBC,self->dbc,SQL_COMMIT);
		switch (ret) {
			case SQL_SUCCESS: return TCL_OK;
			case SQL_SUCCESS_WITH_INFO:
				extract_error_tointerp("commit",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_OK;
			default:
				extract_error_tointerp("commit",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
		}
	}
	Tcl_Result rollback(Tcl_Interp *interp) {
		SQLRETURN ret;
		ret = SQLEndTran(SQL_HANDLE_DBC,self->dbc,SQL_ROLLBACK);
		switch (ret) {
			case SQL_SUCCESS: return TCL_OK;
			case SQL_SUCCESS_WITH_INFO:
				extract_error_tointerp("rollback",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_OK;
			default:
				extract_error_tointerp("rollback",self->dbc,SQL_HANDLE_DBC,interp);
				return TCL_ERROR;
		}
	}
	/* Statement Attributes for internal and future statements.  */
	Tcl_Result statementcget(Tcl_Interp *interp,const char *what) {
		if (strncasecmp(what,"-attr_async_enable",strlen(what)) == 0) {
		    switch (self->attr_async_enable) {
		    	case SQL_ASYNC_ENABLE_OFF:
			    Tcl_SetObjResult(interp,Tcl_NewBooleanObj(0));
			    return TCL_OK;
			case SQL_ASYNC_ENABLE_ON:
			    Tcl_SetObjResult(interp,Tcl_NewBooleanObj(1));
			    return TCL_OK;
		    }
		} else if (strncasecmp(what,"-attr_concurrency",strlen(what)) == 0) {
		    switch (self->attr_concurrency) {
			case SQL_CONCUR_READ_ONLY:
			    Tcl_SetObjResult(interp,Tcl_NewStringObj("read_only",-1));
			    return TCL_OK;
			case SQL_CONCUR_LOCK:
			    Tcl_SetObjResult(interp,Tcl_NewStringObj("lock",-1));
			    return TCL_OK;
			case SQL_CONCUR_ROWVER:
			    Tcl_SetObjResult(interp,Tcl_NewStringObj("rowver",-1));
			    return TCL_OK;
			case SQL_CONCUR_VALUES:
			    Tcl_SetObjResult(interp,Tcl_NewStringObj("values",-1));
			    return TCL_OK;
		    }
		} else if (strncasecmp(what,"-attr_cursor_scrollable",strlen(what)) == 0) {
		    switch (self->attr_cursor_scrollable) {
		    	case SQL_NONSCROLLABLE:
			    Tcl_SetObjResult(interp,Tcl_NewStringObj("nonscrollable",-1));
			    return TCL_OK;
			case SQL_SCROLLABLE:
			    Tcl_SetObjResult(interp,Tcl_NewStringObj("scrollable",-1));
			    return TCL_OK;
		    }
		} else if (strncasecmp(what,"-attr_cursor_sensitivity",strlen(what)) == 0) {
		    switch (self->attr_cursor_sensitivity) {
		    	case SQL_UNSPECIFIED:
			    Tcl_SetObjResult(interp,Tcl_NewStringObj("unspecified",-1));
			    return TCL_OK;
			case SQL_INSENSITIVE:
			    Tcl_SetObjResult(interp,Tcl_NewStringObj("insensitive",-1));
			    return TCL_OK;
			case SQL_SENSITIVE:
			    Tcl_SetObjResult(interp,Tcl_NewStringObj("sensitive",-1));
			    return TCL_OK;
		    }
		} else if (strncasecmp(what,"-attr_cursor_type",strlen(what)) == 0) {
		    switch (self->attr_cursor_type) {
		    	case SQL_CURSOR_FORWARD_ONLY:
			    Tcl_SetObjResult(interp,Tcl_NewStringObj("forward_only",-1));
			    return TCL_OK;
			case SQL_CURSOR_STATIC:
			    Tcl_SetObjResult(interp,Tcl_NewStringObj("static",-1));
			    return TCL_OK;
			case SQL_CURSOR_KEYSET_DRIVEN:
			    Tcl_SetObjResult(interp,Tcl_NewStringObj("keyset_driven",-1));
			    return TCL_OK;
			case SQL_CURSOR_DYNAMIC:
			    Tcl_SetObjResult(interp,Tcl_NewStringObj("dynamic",-1));
			    return TCL_OK;
		    }
		} else if (strncasecmp(what,"-attr_enable_auto_ipd",strlen(what)) == 0) {
		    switch (self->attr_enable_auto_ipd) {
			case SQL_FALSE:
			    Tcl_SetObjResult(interp,Tcl_NewBooleanObj(0));
			    return TCL_OK;
			case SQL_TRUE:
			    Tcl_SetObjResult(interp,Tcl_NewBooleanObj(1));
			    return TCL_OK;
		    }
		} else if (strncasecmp(what,"-attr_keyset_size",strlen(what)) == 0) {
		    Tcl_SetObjResult(interp,Tcl_NewLongObj(self->attr_keyset_size));
		    return TCL_OK;
		} else if (strncasecmp(what,"-attr_max_length",strlen(what)) == 0) {
		    Tcl_SetObjResult(interp,Tcl_NewLongObj(self->attr_max_length));
		    return TCL_OK;
		} else if (strncasecmp(what,"-attr_max_rows",strlen(what)) == 0) {
		    Tcl_SetObjResult(interp,Tcl_NewLongObj(self->attr_max_rows));
		    return TCL_OK;
		} else if (strncasecmp(what,"-attr_metadata_id",strlen(what)) == 0) {
		    switch (self->attr_metadata_id) {
			case SQL_FALSE:
			    Tcl_SetObjResult(interp,Tcl_NewBooleanObj(0));
			    return TCL_OK;
			case SQL_TRUE:
			    Tcl_SetObjResult(interp,Tcl_NewBooleanObj(1));
			    return TCL_OK;
		    }
		} else if (strncasecmp(what,"-attr_noscan",strlen(what)) == 0) {
		    switch (self->attr_noscan) {
			case SQL_NOSCAN_OFF:
			    Tcl_SetObjResult(interp,Tcl_NewBooleanObj(0));
			    return TCL_OK;
			case SQL_NOSCAN_ON:
			    Tcl_SetObjResult(interp,Tcl_NewBooleanObj(1));
			    return TCL_OK;
		    }
		} else if (strncasecmp(what,"-attr_query_timeout",strlen(what)) == 0) {
		    Tcl_SetObjResult(interp,Tcl_NewLongObj(self->attr_query_timeout));
		    return TCL_OK;
		} else if (strncasecmp(what,"-attr_simulate_cursor",strlen(what)) == 0) {
		    switch (self->attr_simulate_cursor) {
			case SQL_SC_NON_UNIQUE:
			    Tcl_SetObjResult(interp,Tcl_NewStringObj("non_unique",-1));
			    return TCL_OK;
			case SQL_SC_TRY_UNIQUE:
			    Tcl_SetObjResult(interp,Tcl_NewStringObj("try_unique",-1));
			    return TCL_OK;
			case SQL_SC_UNIQUE:
			    Tcl_SetObjResult(interp,Tcl_NewStringObj("unique",-1));
			    return TCL_OK;
			default:
			    Tcl_SetObjResult(interp,Tcl_NewStringObj("unknown",-1));
			    return TCL_OK;
		    }
		} else if (strncasecmp(what,"-attr_use_bookmarks",strlen(what)) == 0) {
		    switch (self->attr_use_bookmarks) {
		    	case SQL_UB_OFF:
			    Tcl_SetObjResult(interp,Tcl_NewStringObj("off",-1));
			    return TCL_OK;
		    	case SQL_UB_VARIABLE:
			    Tcl_SetObjResult(interp,Tcl_NewStringObj("variable",-1));
			    return TCL_OK;
		    }
		} else if (strncasecmp(what,"-useMultipleSets",strlen(what)) == 0) {
		    Tcl_SetObjResult(interp,Tcl_NewBooleanObj(self->multiSetsP));
		    return TCL_OK;
		} else {
			Tcl_Obj  *result = Tcl_NewStringObj("Unknown option: \"",-1);
			Tcl_AppendToObj(result,what,-1);
			Tcl_AppendToObj(result,"\", should be one of: ",-1);
			Tcl_AppendToObj(result,"-attr_async_enable ",-1);
			Tcl_AppendToObj(result,"-attr_concurrency ",-1);
			Tcl_AppendToObj(result,"-attr_cursor_scrollable ",-1);
			Tcl_AppendToObj(result,"-attr_cursor_sensitivity ",-1);
			Tcl_AppendToObj(result,"-attr_cursor_type ",-1);
			Tcl_AppendToObj(result,"-attr_enable_auto_ipd ",-1);
			Tcl_AppendToObj(result,"-attr_keyset_size ",-1);
			Tcl_AppendToObj(result,"-attr_max_length ",-1);
			Tcl_AppendToObj(result,"-attr_max_rows ",-1);
			Tcl_AppendToObj(result,"-attr_metadata_id ",-1);
			Tcl_AppendToObj(result,"-attr_noscan ",-1);
			Tcl_AppendToObj(result,"-attr_query_timeout ",-1);
			Tcl_AppendToObj(result,"-attr_simulate_cursor ",-1);
			Tcl_AppendToObj(result,"-attr_use_bookmarks ",-1);
			Tcl_AppendToObj(result,"-useMultipleSets ",-1);
			Tcl_SetObjResult(interp,result);
			return TCL_ERROR;
		}
		return TCL_OK;
	}
	Tcl_Result statementconfigure(Tcl_Interp *interp,const char *what,Tcl_Obj *value) {
 		if (strncasecmp(what,"-attr_async_enable",strlen(what)) == 0) {
		    int btemp;
		    if (Tcl_GetBooleanFromObj(interp,value,&btemp) != TCL_OK) return TCL_ERROR;
		    if (btemp)	self->attr_async_enable = SQL_ASYNC_ENABLE_ON;
		    else	self->attr_async_enable = SQL_ASYNC_ENABLE_OFF;
		} else if (strncasecmp(what,"-attr_concurrency",strlen(what)) == 0) {
		    const char *vs = Tcl_GetString(value);
		    if (strncasecmp(vs,"read_only",strlen(vs)) == 0)
		    	self->attr_concurrency = SQL_CONCUR_READ_ONLY;
		    else if (strncasecmp(vs,"lock",strlen(vs)) == 0)
		    	self->attr_concurrency = SQL_CONCUR_LOCK;
		    else if (strncasecmp(vs,"rowver",strlen(vs)) == 0)
		    	self->attr_concurrency = SQL_CONCUR_ROWVER;
		    else if (strncasecmp(vs,"values",strlen(vs)) == 0)
		    	self->attr_concurrency = SQL_CONCUR_VALUES;
		    else {
		    	Tcl_Obj  *result = Tcl_NewStringObj("Unknown option: \"",-1);
			Tcl_AppendToObj(result,vs,-1);
			Tcl_AppendToObj(result,"\"",-1);
			Tcl_SetObjResult(interp,result);
			return TCL_ERROR;
		    }
		} else if (strncasecmp(what,"-attr_cursor_scrollable",strlen(what)) == 0) {
		    const char *vs = Tcl_GetString(value);
		    if (strncasecmp(vs,"nonscrollable",strlen(vs)) == 0)
		    	self->attr_cursor_scrollable = SQL_NONSCROLLABLE;
		    else if (strncasecmp(vs,"scrollable",strlen(vs)) == 0)
		    	self->attr_cursor_scrollable = SQL_SCROLLABLE;
		    else {
		    	Tcl_Obj  *result = Tcl_NewStringObj("Unknown option: \"",-1);
			Tcl_AppendToObj(result,vs,-1);
			Tcl_AppendToObj(result,"\"",-1);
			Tcl_SetObjResult(interp,result);
			return TCL_ERROR;
		    }
		} else if (strncasecmp(what,"-attr_cursor_sensitivity",strlen(what)) == 0) {
		    const char *vs = Tcl_GetString(value);
		    if (strncasecmp(vs,"unspecified",strlen(vs)) == 0)
			self->attr_cursor_sensitivity = SQL_UNSPECIFIED;
		    else if (strncasecmp(vs,"insensitive",strlen(vs)) == 0)
			self->attr_cursor_sensitivity = SQL_INSENSITIVE;
		    else if (strncasecmp(vs,"sensitive",strlen(vs)) == 0)
			self->attr_cursor_sensitivity = SQL_SENSITIVE;
		    else {
		    	Tcl_Obj  *result = Tcl_NewStringObj("Unknown option: \"",-1);
			Tcl_AppendToObj(result,vs,-1);
			Tcl_AppendToObj(result,"\"",-1);
			Tcl_SetObjResult(interp,result);
			return TCL_ERROR;
		    }
		} else if (strncasecmp(what,"-attr_cursor_type",strlen(what)) == 0) {
		    const char *vs = Tcl_GetString(value);
		    if (strncasecmp(vs,"forward_only",strlen(vs)) == 0)
		    	self->attr_cursor_type = SQL_CURSOR_FORWARD_ONLY;
		    else if (strncasecmp(vs,"static",strlen(vs)) == 0)
		    	self->attr_cursor_type = SQL_CURSOR_STATIC;
		    else if (strncasecmp(vs,"keyset_driven",strlen(vs)) == 0)
		    	self->attr_cursor_type = SQL_CURSOR_KEYSET_DRIVEN;
		    else if (strncasecmp(vs,"dynamic",strlen(vs)) == 0)
		    	self->attr_cursor_type = SQL_CURSOR_DYNAMIC;
		    else {
		    	Tcl_Obj  *result = Tcl_NewStringObj("Unknown option: \"",-1);
			Tcl_AppendToObj(result,vs,-1);
			Tcl_AppendToObj(result,"\"",-1);
			Tcl_SetObjResult(interp,result);
			return TCL_ERROR;
		    }
		} else if (strncasecmp(what,"-attr_enable_auto_ipd",strlen(what)) == 0) {
		    int btemp;
		    if (Tcl_GetBooleanFromObj(interp,value,&btemp) != TCL_OK) return TCL_ERROR;
		    if (btemp)	self->attr_enable_auto_ipd = SQL_TRUE;
		    else	self->attr_enable_auto_ipd = SQL_FALSE;
		} else if (strncasecmp(what,"-attr_keyset_size",strlen(what)) == 0) {
		    SQLUINTEGER temp;
		    if (Tcl_GetLongFromObj(interp,value,&temp) != TCL_OK) return TCL_ERROR;
		    self->attr_keyset_size = temp;
		    return TCL_OK;
		} else if (strncasecmp(what,"-attr_max_length",strlen(what)) == 0) {
		    SQLUINTEGER temp;
		    if (Tcl_GetLongFromObj(interp,value,&temp) != TCL_OK) return TCL_ERROR;
		    self->attr_max_length = temp;
		    return TCL_OK;
		} else if (strncasecmp(what,"-attr_max_rows",strlen(what)) == 0) {
		    SQLUINTEGER temp;
		    if (Tcl_GetLongFromObj(interp,value,&temp) != TCL_OK) return TCL_ERROR;
		    self->attr_max_rows = temp;
		    return TCL_OK;
		} else if (strncasecmp(what,"-attr_metadata_id",strlen(what)) == 0) {
		    int btemp;
		    if (Tcl_GetBooleanFromObj(interp,value,&btemp) != TCL_OK) return TCL_ERROR;
		    if (btemp)	self->attr_metadata_id = SQL_TRUE;
		    else	self->attr_metadata_id = SQL_FALSE;
		} else if (strncasecmp(what,"-attr_noscan",strlen(what)) == 0) {
		    int btemp;
		    if (Tcl_GetBooleanFromObj(interp,value,&btemp) != TCL_OK) return TCL_ERROR;
		    if (btemp)	self->attr_noscan = SQL_NOSCAN_ON;
		    else	self->attr_noscan = SQL_NOSCAN_OFF;
		} else if (strncasecmp(what,"-attr_query_timeout",strlen(what)) == 0) {
		    SQLUINTEGER temp;
		    if (Tcl_GetLongFromObj(interp,value,&temp) != TCL_OK) return TCL_ERROR;
		    self->attr_query_timeout = temp;
		    return TCL_OK;
		} else if (strncasecmp(what,"-attr_simulate_cursor",strlen(what)) == 0) {
		    const char *vs = Tcl_GetString(value);
		    if (strncasecmp(vs,"non_unique",strlen(vs)) == 0)
		    	self->attr_simulate_cursor = SQL_SC_NON_UNIQUE;
		    else if (strncasecmp(vs,"try_unique",strlen(vs)) == 0)
		    	self->attr_simulate_cursor = SQL_SC_TRY_UNIQUE;
		    else if (strncasecmp(vs,"unique",strlen(vs)) == 0)
		    	self->attr_simulate_cursor = SQL_SC_UNIQUE;
		    else {
		    	Tcl_Obj  *result = Tcl_NewStringObj("Unknown option: \"",-1);
			Tcl_AppendToObj(result,vs,-1);
			Tcl_AppendToObj(result,"\"",-1);
			Tcl_SetObjResult(interp,result);
			return TCL_ERROR;
		    }
		} else if (strncasecmp(what,"-attr_use_bookmarks",strlen(what)) == 0) {
		    const char *vs = Tcl_GetString(value);
		    if (strncasecmp(vs,"off",strlen(vs)) == 0)
		    	self->attr_use_bookmarks = SQL_UB_OFF;
		    else if (strncasecmp(vs,"variable",strlen(vs)) == 0)
		    	self->attr_use_bookmarks = SQL_UB_VARIABLE;
		    else if (strncasecmp(vs,"fixed",strlen(vs)) == 0)
		    	self->attr_use_bookmarks = SQL_UB_VARIABLE;
		    else {
		    	Tcl_Obj  *result = Tcl_NewStringObj("Unknown option: \"",-1);
			Tcl_AppendToObj(result,vs,-1);
			Tcl_AppendToObj(result,"\"",-1);
			Tcl_SetObjResult(interp,result);
			return TCL_ERROR;
		    }
		} else if (strncasecmp(what,"-useMultipleSets",strlen(what)) == 0) {
		    return Tcl_GetBooleanFromObj(interp,value,&(self->multiSetsP));
		} else {
			Tcl_Obj  *result = Tcl_NewStringObj("Unknown option: \"",-1);
			Tcl_AppendToObj(result,what,-1);
			Tcl_AppendToObj(result,"\", should be one of: ",-1);
			Tcl_AppendToObj(result,"-attr_async_enable ",-1);
			Tcl_AppendToObj(result,"-attr_concurrency ",-1);
			Tcl_AppendToObj(result,"-attr_cursor_scrollable ",-1);
			Tcl_AppendToObj(result,"-attr_cursor_sensitivity ",-1);
			Tcl_AppendToObj(result,"-attr_cursor_type ",-1);
			Tcl_AppendToObj(result,"-attr_enable_auto_ipd ",-1);
			Tcl_AppendToObj(result,"-attr_keyset_size ",-1);
			Tcl_AppendToObj(result,"-attr_max_length ",-1);
			Tcl_AppendToObj(result,"-attr_max_rows ",-1);
			Tcl_AppendToObj(result,"-attr_metadata_id ",-1);
			Tcl_AppendToObj(result,"-attr_noscan ",-1);
			Tcl_AppendToObj(result,"-attr_query_timeout ",-1);
			Tcl_AppendToObj(result,"-attr_simulate_cursor ",-1);
			Tcl_AppendToObj(result,"-attr_use_bookmarks ",-1);
			Tcl_AppendToObj(result,"-useMultipleSets ",-1);
			Tcl_SetObjResult(interp,result);
			return TCL_ERROR;
		}
		return TCL_OK;
	}
	/* Direct statement functions. */
	Tcl_Result run(Tcl_Interp *interp,const char *sql,Tcl_Obj *a=NULL,Tcl_Obj *b=NULL) {
		Tcl_Obj *argtypedefs, *args;
		int ret;
		if (a == NULL && b == NULL) {
		    argtypedefs = NULL;
		    args = NULL;
		} else if (b == NULL) {
		    argtypedefs = NULL;
		    args = a;
		} else {
		    argtypedefs = a;
		    args = b;
		}
		char *errorMessage = NULL;
		struct statement *tempStatement = CreateStatement(interp,self,sql,argtypedefs,&errorMessage);
		if (errorMessage != NULL) {
			Tcl_SetObjResult(interp,Tcl_NewStringObj(errorMessage,-1));
			Tcl_Free(errorMessage);
			return TCL_ERROR;
		}
		ret = RunStatement(interp,tempStatement,args);
		DestroyStatement(tempStatement);
		return ret;
	}
	Tcl_Result eval(Tcl_Interp *interp,Tcl_Obj *proc,const char *sql,Tcl_Obj *a=NULL,Tcl_Obj *b=NULL) {
		Tcl_Obj *argtypedefs, *args;
		int ret;
		if (a == NULL && b == NULL) {
		    argtypedefs = NULL;
		    args = NULL;
		} else if (b == NULL) {
		    argtypedefs = NULL;
		    args = a;
		} else {
		    argtypedefs = a;
		    args = b;
		}
		char *errorMessage = NULL;
		struct statement *tempStatement = CreateStatement(interp,self,sql,argtypedefs,&errorMessage);
		if (errorMessage != NULL) {
			Tcl_SetObjResult(interp,Tcl_NewStringObj(errorMessage,-1));
			Tcl_Free(errorMessage);
			return TCL_ERROR;
		}
		ret = EvalStatement(interp,proc,tempStatement,args);
		DestroyStatement(tempStatement);
		return ret;
	}
	Tcl_Result read(Tcl_Interp *interp,Tcl_Obj *arrayspec,const char *sql,Tcl_Obj *a=NULL,Tcl_Obj *b=NULL) {
		Tcl_Obj *argtypedefs, *args;
		int ret;
		if (a == NULL && b == NULL) {
		    argtypedefs = NULL;
		    args = NULL;
		} else if (b == NULL) {
		    argtypedefs = NULL;
		    args = a;
		} else {
		    argtypedefs = a;
		    args = b;
		}
		char *errorMessage = NULL;
		struct statement *tempStatement = CreateStatement(interp,self,sql,argtypedefs,&errorMessage);
		if (errorMessage != NULL) {
			Tcl_SetObjResult(interp,Tcl_NewStringObj(errorMessage,-1));
			Tcl_Free(errorMessage);
			return TCL_ERROR;
		}
		ret = ReadStatement(interp,arrayspec,tempStatement,args);
		DestroyStatement(tempStatement);
		return ret;
	}
	/* Statement create function */
	struct statement *statement(Tcl_Interp *interp,const char *sql,Tcl_Obj *argtypedefs=NULL,char **outmessage=NULL) {
		return CreateStatement(interp,self,sql,argtypedefs,outmessage);
	}	
}

